{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  LLL(Int, Num, Nat, Rat, Poly, Vec, weak_test, strict_test, short_norm_test,
       lLL_factorization_test, factorization_algorithm_16_22_test)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified IArray;
import qualified Uint32;
import qualified Uint64;
import qualified Data_Bits;

newtype Int = Int_of_integer Integer;

integer_of_int :: Int -> Integer;
integer_of_int (Int_of_integer k) = k;

times_int :: Int -> Int -> Int;
times_int k l = Int_of_integer (integer_of_int k * integer_of_int l);

zero_int :: Int;
zero_int = Int_of_integer (0 :: Integer);

data Num = One | Bit0 Num | Bit1 Num;

one_int :: Int;
one_int = Int_of_integer (1 :: Integer);

class Times a where {
  times :: a -> a -> a;
};

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if (0 :: Integer) < l
           then (if (0 :: Integer) < k then divMod ( k ) ( l )
                  else (case divMod ( (negate k) ) ( l ) of {
                         (r, s) ->
                           (if s == (0 :: Integer)
                             then (negate r, (0 :: Integer))
                             else (negate r - (1 :: Integer), l - s));
                       }))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else apsnd negate
                         (if k < (0 :: Integer)
                           then divMod ( (negate k) ) ( (negate l) )
                           else (case divMod ( k ) ( (negate l) ) of {
                                  (r, s) ->
                                    (if s == (0 :: Integer)
                                      then (negate r, (0 :: Integer))
                                      else (negate r - (1 :: Integer),
     negate l - s));
                                })))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

lcm_integer :: Integer -> Integer -> Integer;
lcm_integer a b =
  divide_integer (Prelude.abs a * Prelude.abs b) (Prelude.gcd a b);

lcm_inta :: Int -> Int -> Int;
lcm_inta (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (lcm_integer x y);

gcd_inta :: Int -> Int -> Int;
gcd_inta (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (Prelude.gcd x y);

data Color = R | B;

data Rbt a b = Empty | Branch Color (Rbt a b) a b (Rbt a b);

data Ordera = Eqa | Lt | Gt;

class Ccompare a where {
  ccompare :: Maybe (a -> a -> Ordera);
};

newtype Mapping_rbt b a = Mapping_RBT (Rbt b a);

class Ceq a where {
  ceq :: Maybe (a -> a -> Bool);
};

newtype Set_dlist a = Abs_dlist [a];

data Set a = Collect_set (a -> Bool) | DList_set (Set_dlist a)
  | RBT_set (Mapping_rbt a ()) | Set_Monad [a] | Complement (Set a);

class Zero a where {
  zero :: a;
};

class One a where {
  one :: a;
};

class (Times a) => Dvd a where {
};

class (One a, Zero a, Dvd a) => Gcda a where {
  gcda :: a -> a -> a;
  lcma :: a -> a -> a;
};

class (Gcda a) => Gcd a where {
  gcd :: Set a -> a;
  lcm :: Set a -> a;
};

dummy_Lcm :: forall a. (Gcd a) => Set a -> a;
dummy_Lcm x = lcm x;

dummy_Gcd :: forall a. Set a -> a;
dummy_Gcd _ = error "Code_Abort_Gcd.dummy_Gcd";

gcd_int :: Set Int -> Int;
gcd_int x = dummy_Gcd x;

instance Zero Int where {
  zero = zero_int;
};

instance One Int where {
  one = one_int;
};

instance Times Int where {
  times = times_int;
};

instance Dvd Int where {
};

instance Gcda Int where {
  gcda = gcd_inta;
  lcma = lcm_inta;
};

instance Gcd Int where {
  gcd = gcd_int;
  lcm = lcm_int;
};

lcm_int :: Set Int -> Int;
lcm_int x = dummy_Lcm x;

equal_int :: Int -> Int -> Bool;
equal_int k l = integer_of_int k == integer_of_int l;

instance Eq Int where {
  a == b = equal_int a b;
};

uminus_int :: Int -> Int;
uminus_int k = Int_of_integer (negate (integer_of_int k));

less_int :: Int -> Int -> Bool;
less_int k l = integer_of_int k < integer_of_int l;

abs_int :: Int -> Int;
abs_int i = (if less_int i zero_int then uminus_int i else i);

class Abs a where {
  absa :: a -> a;
};

instance Abs Int where {
  absa = abs_int;
};

minus_int :: Int -> Int -> Int;
minus_int k l = Int_of_integer (integer_of_int k - integer_of_int l);

plus_int :: Int -> Int -> Int;
plus_int k l = Int_of_integer (integer_of_int k + integer_of_int l);

class Uminus a where {
  uminus :: a -> a;
};

class Minus a where {
  minus :: a -> a -> a;
};

class Plus a where {
  plus :: a -> a -> a;
};

class (Plus a) => Semigroup_add a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Times a, Zero a) => Mult_zero a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class (One a, Times a) => Power a where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Ab_semigroup_mult a, Monoid_mult a, Dvd a) => Comm_monoid_mult a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Comm_semiring_1_cancel a) => Comm_semiring_1_cancel_crossproduct a where {
};

class (Semiring_0 a) => Semiring_no_zero_divisors a where {
};

class (Semiring_1 a,
        Semiring_no_zero_divisors a) => Semiring_1_no_zero_divisors a where {
};

class (Semiring_no_zero_divisors a) => Semiring_no_zero_divisors_cancel a where {
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (Ab_group_add a, Semiring_0_cancel a) => Ring a where {
};

class (Ring a,
        Semiring_no_zero_divisors_cancel a) => Ring_no_zero_divisors a where {
};

class (Group_add a, Numeral a) => Neg_numeral a where {
};

class (Neg_numeral a, Ring a, Semiring_1_cancel a) => Ring_1 a where {
};

class (Ring_1 a, Ring_no_zero_divisors a,
        Semiring_1_no_zero_divisors a) => Ring_1_no_zero_divisors a where {
};

class (Comm_semiring_0_cancel a, Ring a) => Comm_ring a where {
};

class (Comm_ring a, Comm_semiring_1_cancel a, Ring_1 a) => Comm_ring_1 a where {
};

class (Comm_semiring_1_cancel a,
        Semiring_1_no_zero_divisors a) => Semidom a where {
};

class (Comm_ring_1 a, Ring_1_no_zero_divisors a, Semidom a,
        Comm_semiring_1_cancel_crossproduct a) => Idom a where {
};

instance Plus Int where {
  plus = plus_int;
};

instance Semigroup_add Int where {
};

instance Cancel_semigroup_add Int where {
};

instance Ab_semigroup_add Int where {
};

instance Minus Int where {
  minus = minus_int;
};

instance Cancel_ab_semigroup_add Int where {
};

instance Monoid_add Int where {
};

instance Comm_monoid_add Int where {
};

instance Cancel_comm_monoid_add Int where {
};

instance Mult_zero Int where {
};

instance Semigroup_mult Int where {
};

instance Semiring Int where {
};

instance Semiring_0 Int where {
};

instance Semiring_0_cancel Int where {
};

instance Ab_semigroup_mult Int where {
};

instance Comm_semiring Int where {
};

instance Comm_semiring_0 Int where {
};

instance Comm_semiring_0_cancel Int where {
};

instance Power Int where {
};

instance Monoid_mult Int where {
};

instance Numeral Int where {
};

instance Semiring_numeral Int where {
};

instance Zero_neq_one Int where {
};

instance Semiring_1 Int where {
};

instance Semiring_1_cancel Int where {
};

instance Comm_monoid_mult Int where {
};

instance Comm_semiring_1 Int where {
};

instance Comm_semiring_1_cancel Int where {
};

instance Comm_semiring_1_cancel_crossproduct Int where {
};

instance Semiring_no_zero_divisors Int where {
};

instance Semiring_1_no_zero_divisors Int where {
};

instance Semiring_no_zero_divisors_cancel Int where {
};

instance Uminus Int where {
  uminus = uminus_int;
};

instance Group_add Int where {
};

instance Ab_group_add Int where {
};

instance Ring Int where {
};

instance Ring_no_zero_divisors Int where {
};

instance Neg_numeral Int where {
};

instance Ring_1 Int where {
};

instance Ring_1_no_zero_divisors Int where {
};

instance Comm_ring Int where {
};

instance Comm_ring_1 Int where {
};

instance Semidom Int where {
};

instance Idom Int where {
};

normalize_int :: Int -> Int;
normalize_int = abs_int;

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i zero_int then zero_int
    else (if less_int zero_int i then one_int else uminus_int one_int));

unit_factor_int :: Int -> Int;
unit_factor_int = sgn_int;

class Divide a where {
  divide :: a -> a -> a;
};

class (Divide a, Semidom a,
        Semiring_no_zero_divisors_cancel a) => Semidom_divide a where {
};

class Unit_factor a where {
  unit_factor :: a -> a;
};

class (Semidom_divide a, Unit_factor a) => Semidom_divide_unit_factor a where {
};

class (Semidom_divide a) => Algebraic_semidom a where {
};

class (Algebraic_semidom a,
        Semidom_divide_unit_factor a) => Normalization_semidom a where {
  normalizea :: a -> a;
};

divide_int :: Int -> Int -> Int;
divide_int k l =
  Int_of_integer (divide_integer (integer_of_int k) (integer_of_int l));

class (Gcda a, Comm_semiring_1 a) => Comm_monoid_gcd a where {
};

class (Idom a, Comm_monoid_gcd a) => Idom_gcd a where {
};

class (Normalization_semidom a, Comm_monoid_gcd a) => Semiring_gcd a where {
};

class (Semiring_gcd a, Idom_gcd a) => Ring_gcd a where {
};

instance Comm_monoid_gcd Int where {
};

instance Idom_gcd Int where {
};

instance Divide Int where {
  divide = divide_int;
};

instance Semidom_divide Int where {
};

instance Unit_factor Int where {
  unit_factor = unit_factor_int;
};

instance Semidom_divide_unit_factor Int where {
};

instance Algebraic_semidom Int where {
};

instance Normalization_semidom Int where {
  normalizea = normalize_int;
};

instance Semiring_gcd Int where {
};

instance Ring_gcd Int where {
};

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_int :: Int -> Int -> Int;
modulo_int k l =
  Int_of_integer (modulo_integer (integer_of_int k) (integer_of_int l));

class (Divide a, Dvd a) => Modulo a where {
  modulo :: a -> a -> a;
};

instance Modulo Int where {
  modulo = modulo_int;
};

less_eq_int :: Int -> Int -> Bool;
less_eq_int k l = integer_of_int k <= integer_of_int l;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

instance Ord Int where {
  less_eq = less_eq_int;
  less = less_int;
};

class (Gcd a, Semiring_gcd a) => Semiring_Gcd a where {
};

instance Semiring_Gcd Int where {
};

class (Idom a, Semidom_divide a) => Idom_divide a where {
};

instance Idom_divide Int where {
};

conjugate_int :: Int -> Int;
conjugate_int x = x;

class Conjugate a where {
  conjugate :: a -> a;
};

instance Conjugate Int where {
  conjugate = conjugate_int;
};

class (Comm_semiring_1_cancel a, Modulo a) => Semiring_modulo a where {
};

instance Semiring_modulo Int where {
};

class (Algebraic_semidom a, Semiring_modulo a) => Semidom_modulo a where {
};

class (Semidom_modulo a, Idom_divide a) => Idom_modulo a where {
};

instance Semidom_modulo Int where {
};

instance Idom_modulo Int where {
};

newtype Nat = Nat Integer;

class (Normalization_semidom a) => Factorial_semiring a where {
};

class (Semidom_modulo a, Factorial_semiring a) => Euclidean_semiring a where {
  euclidean_size :: a -> Nat;
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

nat :: Int -> Nat;
nat k = Nat (max (0 :: Integer) (integer_of_int k));

euclidean_size_int :: Int -> Nat;
euclidean_size_int = nat . abs_int;

class (Euclidean_semiring a, Idom_modulo a) => Euclidean_ring a where {
};

instance Factorial_semiring Int where {
};

instance Euclidean_semiring Int where {
  euclidean_size = euclidean_size_int;
};

instance Euclidean_ring Int where {
};

class (Factorial_semiring a, Semiring_Gcd a) => Factorial_semiring_gcd a where {
};

class (Factorial_semiring_gcd a, Ring_gcd a,
        Idom_divide a) => Factorial_ring_gcd a where {
};

instance Factorial_semiring_gcd Int where {
};

instance Factorial_ring_gcd Int where {
};

class (Euclidean_semiring a,
        Factorial_semiring_gcd a) => Euclidean_semiring_gcd a where {
};

class (Euclidean_semiring_gcd a, Euclidean_ring a,
        Factorial_ring_gcd a) => Euclidean_ring_gcd a where {
};

instance Euclidean_semiring_gcd Int where {
};

instance Euclidean_ring_gcd Int where {
};

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

instance Times Nat where {
  times = times_nat;
};

instance Dvd Nat where {
};

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

instance One Nat where {
  one = one_nat;
};

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

instance Plus Nat where {
  plus = plus_nat;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

instance Zero Nat where {
  zero = zero_nat;
};

instance Semigroup_add Nat where {
};

instance Numeral Nat where {
};

instance Power Nat where {
};

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

instance Minus Nat where {
  minus = minus_nat;
};

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

instance Divide Nat where {
  divide = divide_nat;
};

modulo_nat :: Nat -> Nat -> Nat;
modulo_nat m n = Nat (modulo_integer (integer_of_nat m) (integer_of_nat n));

instance Modulo Nat where {
  modulo = modulo_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

instance Ab_semigroup_add Nat where {
};

instance Monoid_add Nat where {
};

instance Comm_monoid_add Nat where {
};

instance Mult_zero Nat where {
};

instance Semigroup_mult Nat where {
};

instance Semiring Nat where {
};

instance Semiring_0 Nat where {
};

instance Semiring_no_zero_divisors Nat where {
};

instance Monoid_mult Nat where {
};

instance Semiring_numeral Nat where {
};

instance Zero_neq_one Nat where {
};

instance Semiring_1 Nat where {
};

instance Semiring_1_no_zero_divisors Nat where {
};

instance Cancel_semigroup_add Nat where {
};

instance Cancel_ab_semigroup_add Nat where {
};

instance Cancel_comm_monoid_add Nat where {
};

instance Semiring_0_cancel Nat where {
};

instance Ab_semigroup_mult Nat where {
};

instance Comm_semiring Nat where {
};

instance Comm_semiring_0 Nat where {
};

instance Comm_semiring_0_cancel Nat where {
};

instance Semiring_1_cancel Nat where {
};

instance Comm_monoid_mult Nat where {
};

instance Comm_semiring_1 Nat where {
};

instance Comm_semiring_1_cancel Nat where {
};

instance Semidom Nat where {
};

class (Ord a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

instance Preorder Nat where {
};

instance Order Nat where {
};

class (Order a) => Linorder a where {
};

instance Linorder Nat where {
};

instance Semiring_no_zero_divisors_cancel Nat where {
};

instance Semidom_divide Nat where {
};

instance Semiring_modulo Nat where {
};

instance Algebraic_semidom Nat where {
};

instance Semidom_modulo Nat where {
};

newtype Rat = Frct (Int, Int);

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int zero_int (snd p)
    then let {
           a = gcd_inta (fst p) (snd p);
         } in (divide_int (fst p) a, divide_int (snd p) a)
    else (if equal_int (snd p) zero_int then (zero_int, one_int)
           else let {
                  a = uminus_int (gcd_inta (fst p) (snd p));
                } in (divide_int (fst p) a, divide_int (snd p) a)));

times_rat :: Rat -> Rat -> Rat;
times_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) -> normalize (times_int aa ba, times_int c d);
                      });
             }));

instance Times Rat where {
  times = times_rat;
};

instance Dvd Rat where {
};

abs_rat :: Rat -> Rat;
abs_rat p = Frct (let {
                    a = quotient_of p;
                  } in (case a of {
                         (aa, b) -> (abs_int aa, b);
                       }));

instance Abs Rat where {
  absa = abs_rat;
};

one_rat :: Rat;
one_rat = Frct (one_int, one_int);

instance One Rat where {
  one = one_rat;
};

sgn_rat :: Rat -> Rat;
sgn_rat p = Frct (sgn_int (fst (quotient_of p)), one_int);

class Sgn a where {
  sgn :: a -> a;
};

instance Sgn Rat where {
  sgn = sgn_rat;
};

uminus_rat :: Rat -> Rat;
uminus_rat p = Frct (let {
                       a = quotient_of p;
                     } in (case a of {
                            (aa, b) -> (uminus_int aa, b);
                          }));

minus_rat :: Rat -> Rat -> Rat;
minus_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) ->
                          normalize
                            (minus_int (times_int aa d) (times_int ba c),
                              times_int c d);
                      });
             }));

zero_rat :: Rat;
zero_rat = Frct (zero_int, one_int);

plus_rat :: Rat -> Rat -> Rat;
plus_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) ->
                          normalize
                            (plus_int (times_int aa d) (times_int ba c),
                              times_int c d);
                      });
             }));

instance Plus Rat where {
  plus = plus_rat;
};

instance Semigroup_add Rat where {
};

instance Cancel_semigroup_add Rat where {
};

instance Ab_semigroup_add Rat where {
};

instance Minus Rat where {
  minus = minus_rat;
};

instance Cancel_ab_semigroup_add Rat where {
};

instance Zero Rat where {
  zero = zero_rat;
};

instance Monoid_add Rat where {
};

instance Comm_monoid_add Rat where {
};

instance Cancel_comm_monoid_add Rat where {
};

instance Mult_zero Rat where {
};

instance Semigroup_mult Rat where {
};

instance Semiring Rat where {
};

instance Semiring_0 Rat where {
};

instance Semiring_0_cancel Rat where {
};

instance Ab_semigroup_mult Rat where {
};

instance Comm_semiring Rat where {
};

instance Comm_semiring_0 Rat where {
};

instance Comm_semiring_0_cancel Rat where {
};

instance Power Rat where {
};

instance Monoid_mult Rat where {
};

instance Numeral Rat where {
};

instance Semiring_numeral Rat where {
};

instance Zero_neq_one Rat where {
};

instance Semiring_1 Rat where {
};

instance Semiring_1_cancel Rat where {
};

instance Comm_monoid_mult Rat where {
};

instance Comm_semiring_1 Rat where {
};

instance Comm_semiring_1_cancel Rat where {
};

instance Comm_semiring_1_cancel_crossproduct Rat where {
};

instance Semiring_no_zero_divisors Rat where {
};

instance Semiring_1_no_zero_divisors Rat where {
};

instance Semiring_no_zero_divisors_cancel Rat where {
};

instance Uminus Rat where {
  uminus = uminus_rat;
};

instance Group_add Rat where {
};

instance Ab_group_add Rat where {
};

instance Ring Rat where {
};

instance Ring_no_zero_divisors Rat where {
};

instance Neg_numeral Rat where {
};

instance Ring_1 Rat where {
};

instance Ring_1_no_zero_divisors Rat where {
};

instance Comm_ring Rat where {
};

instance Comm_ring_1 Rat where {
};

instance Semidom Rat where {
};

instance Idom Rat where {
};

inverse_rat :: Rat -> Rat;
inverse_rat p =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, b) ->
                 (if equal_int aa zero_int then (zero_int, one_int)
                   else (times_int (sgn_int aa) b, abs_int aa));
             }));

divide_rat :: Rat -> Rat -> Rat;
divide_rat p q =
  Frct (let {
          a = quotient_of p;
        } in (case a of {
               (aa, c) ->
                 let {
                   b = quotient_of q;
                 } in (case b of {
                        (ba, d) -> normalize (times_int aa d, times_int c ba);
                      });
             }));

class (Divide a) => Inverse a where {
  inverse :: a -> a;
};

class (Idom a) => Ufd a where {
};

class (Inverse a, Ring_1_no_zero_divisors a) => Division_ring a where {
};

class (Division_ring a, Idom_divide a, Ufd a) => Field a where {
};

instance Ufd Rat where {
};

instance Divide Rat where {
  divide = divide_rat;
};

instance Inverse Rat where {
  inverse = inverse_rat;
};

instance Division_ring Rat where {
};

instance Semidom_divide Rat where {
};

instance Idom_divide Rat where {
};

instance Field Rat where {
};

less_eq_rat :: Rat -> Rat -> Bool;
less_eq_rat p q =
  let {
    a = quotient_of p;
  } in (case a of {
         (aa, c) ->
           let {
             b = quotient_of q;
           } in (case b of {
                  (ba, d) -> less_eq_int (times_int aa d) (times_int c ba);
                });
       });

less_rat :: Rat -> Rat -> Bool;
less_rat p q =
  let {
    a = quotient_of p;
  } in (case a of {
         (aa, c) ->
           let {
             b = quotient_of q;
           } in (case b of {
                  (ba, d) -> less_int (times_int aa d) (times_int c ba);
                });
       });

class (Abs a, Minus a, Uminus a, Zero a, Ord a) => Abs_if a where {
};

instance Ord Rat where {
  less_eq = less_eq_rat;
  less = less_rat;
};

instance Abs_if Rat where {
};

class (Semiring_1 a) => Semiring_char_0 a where {
};

class (Semiring_char_0 a, Ring_1 a) => Ring_char_0 a where {
};

instance Semiring_char_0 Rat where {
};

instance Ring_char_0 Rat where {
};

instance Preorder Rat where {
};

instance Order Rat where {
};

class (Order a) => No_bot a where {
};

instance No_bot Rat where {
};

class (Order a) => No_top a where {
};

instance No_top Rat where {
};

instance Linorder Rat where {
};

class (Abs a, Sgn a, Idom a) => Idom_abs_sgn a where {
};

instance Idom_abs_sgn Rat where {
};

class (Ab_semigroup_add a, Order a) => Ordered_ab_semigroup_add a where {
};

class (Ordered_ab_semigroup_add a) => Strict_ordered_ab_semigroup_add a where {
};

class (Cancel_ab_semigroup_add a,
        Strict_ordered_ab_semigroup_add a) => Ordered_cancel_ab_semigroup_add a where {
};

class (Comm_monoid_add a,
        Ordered_ab_semigroup_add a) => Ordered_comm_monoid_add a where {
};

class (Ordered_comm_monoid_add a, Semiring a) => Ordered_semiring a where {
};

class (Ordered_semiring a, Semiring_0 a) => Ordered_semiring_0 a where {
};

class (Ordered_cancel_ab_semigroup_add a, Ordered_semiring_0 a,
        Semiring_0_cancel a) => Ordered_cancel_semiring a where {
};

class (Ordered_cancel_ab_semigroup_add a) => Ordered_ab_semigroup_add_imp_le a where {
};

class (Comm_monoid_add a,
        Strict_ordered_ab_semigroup_add a) => Strict_ordered_comm_monoid_add a where {
};

class (Ordered_cancel_ab_semigroup_add a, Ordered_comm_monoid_add a,
        Strict_ordered_comm_monoid_add a) => Ordered_cancel_comm_monoid_add a where {
};

class (Cancel_comm_monoid_add a, Ordered_ab_semigroup_add_imp_le a,
        Ordered_cancel_comm_monoid_add a) => Ordered_ab_semigroup_monoid_add_imp_le a where {
};

class (Ab_group_add a,
        Ordered_ab_semigroup_monoid_add_imp_le a) => Ordered_ab_group_add a where {
};

class (Ordered_ab_group_add a, Ordered_cancel_semiring a,
        Ring a) => Ordered_ring a where {
};

instance Ordered_ab_semigroup_add Rat where {
};

instance Strict_ordered_ab_semigroup_add Rat where {
};

instance Ordered_cancel_ab_semigroup_add Rat where {
};

instance Ordered_comm_monoid_add Rat where {
};

instance Ordered_semiring Rat where {
};

instance Ordered_semiring_0 Rat where {
};

instance Ordered_cancel_semiring Rat where {
};

instance Ordered_ab_semigroup_add_imp_le Rat where {
};

instance Strict_ordered_comm_monoid_add Rat where {
};

instance Ordered_cancel_comm_monoid_add Rat where {
};

instance Ordered_ab_semigroup_monoid_add_imp_le Rat where {
};

instance Ordered_ab_group_add Rat where {
};

instance Ordered_ring Rat where {
};

conjugate_rat :: Rat -> Rat;
conjugate_rat x = x;

instance Conjugate Rat where {
  conjugate = conjugate_rat;
};

class (Field a, Ring_char_0 a) => Field_char_0 a where {
};

instance Field_char_0 Rat where {
};

class (Order a, Zero_neq_one a) => Zero_less_one a where {
};

instance Zero_less_one Rat where {
};

class (Field a, Idom_abs_sgn a) => Field_abs_sgn a where {
};

instance Field_abs_sgn Rat where {
};

class (Order a) => Dense_order a where {
};

instance Dense_order Rat where {
};

class (Ordered_ab_semigroup_add a,
        Linorder a) => Linordered_ab_semigroup_add a where {
};

class (Linordered_ab_semigroup_add a,
        Ordered_ab_semigroup_add_imp_le a) => Linordered_cancel_ab_semigroup_add a where {
};

class (Linordered_cancel_ab_semigroup_add a,
        Ordered_ab_semigroup_monoid_add_imp_le a,
        Ordered_cancel_semiring a) => Linordered_semiring a where {
};

class (Linordered_semiring a) => Linordered_semiring_strict a where {
};

class (Linordered_semiring a, Semiring_1 a) => Linordered_semiring_1 a where {
};

class (Linordered_semiring_1 a,
        Linordered_semiring_strict a) => Linordered_semiring_1_strict a where {
};

class (Abs a, Ordered_ab_group_add a) => Ordered_ab_group_add_abs a where {
};

class (Linordered_cancel_ab_semigroup_add a,
        Ordered_ab_group_add a) => Linordered_ab_group_add a where {
};

class (Linordered_ab_group_add a, Ordered_ab_group_add_abs a, Abs_if a,
        Linordered_semiring a, Ordered_ring a) => Linordered_ring a where {
};

class (Linordered_ring a, Linordered_semiring_strict a,
        Ring_no_zero_divisors a) => Linordered_ring_strict a where {
};

class (Ordered_semiring_0 a, Semiring_1 a,
        Zero_less_one a) => Ordered_semiring_1a a where {
};

class (Ordered_cancel_ab_semigroup_add a, Ordered_semiring a,
        Semiring_0_cancel a) => Ordered_semiring_strict a where {
};

class (Ordered_semiring_strict a,
        Ordered_semiring_0 a) => Semiring_real_line a where {
};

class (Ordered_semiring_1a a,
        Semiring_real_line a) => Semiring_1_real_line a where {
};

class (Comm_semiring_0 a, Ordered_semiring a) => Ordered_comm_semiring a where {
};

class (Comm_semiring_0_cancel a, Ordered_cancel_semiring a,
        Ordered_comm_semiring a) => Ordered_cancel_comm_semiring a where {
};

class (Linordered_semiring_strict a,
        Ordered_cancel_comm_semiring a) => Linordered_comm_semiring_strict a where {
};

class (Linorder a, Comm_semiring_1 a, Ordered_comm_semiring a,
        Zero_less_one a) => Linordered_nonzero_semiring a where {
};

class (Semiring_char_0 a, Linordered_comm_semiring_strict a,
        Linordered_nonzero_semiring a,
        Semidom a) => Linordered_semidom a where {
};

class (Comm_ring a, Ordered_cancel_comm_semiring a,
        Ordered_ring a) => Ordered_comm_ring a where {
};

class (Ordered_ab_group_add_abs a, Ordered_ring a) => Ordered_ring_abs a where {
};

class (Ring_char_0 a, Semiring_1_real_line a, Idom_abs_sgn a,
        Linordered_ring_strict a, Linordered_semidom a,
        Linordered_semiring_1_strict a, Ordered_comm_ring a,
        Ordered_ring_abs a) => Linordered_idom a where {
};

instance Linordered_ab_semigroup_add Rat where {
};

instance Linordered_cancel_ab_semigroup_add Rat where {
};

instance Linordered_semiring Rat where {
};

instance Linordered_semiring_strict Rat where {
};

instance Linordered_semiring_1 Rat where {
};

instance Linordered_semiring_1_strict Rat where {
};

instance Ordered_ab_group_add_abs Rat where {
};

instance Linordered_ab_group_add Rat where {
};

instance Linordered_ring Rat where {
};

instance Linordered_ring_strict Rat where {
};

instance Ordered_semiring_1a Rat where {
};

instance Ordered_semiring_strict Rat where {
};

instance Semiring_real_line Rat where {
};

instance Semiring_1_real_line Rat where {
};

instance Ordered_comm_semiring Rat where {
};

instance Ordered_cancel_comm_semiring Rat where {
};

instance Linordered_comm_semiring_strict Rat where {
};

instance Linordered_nonzero_semiring Rat where {
};

instance Linordered_semidom Rat where {
};

instance Ordered_comm_ring Rat where {
};

instance Ordered_ring_abs Rat where {
};

instance Linordered_idom Rat where {
};

class (Ord a) => Non_strict_order a where {
};

class (Ab_semigroup_add a, Monoid_add a,
        Non_strict_order a) => Ordered_ab_semigroup a where {
};

class (Semiring_0 a, Ordered_ab_semigroup a) => Ordered_semiring_0a a where {
};

class (Semiring_1 a, Ordered_semiring_0a a) => Ordered_semiring_1 a where {
};

class (Comm_semiring_1 a, Ordered_semiring_1 a) => Poly_carrier a where {
};

instance Non_strict_order Rat where {
};

instance Ordered_ab_semigroup Rat where {
};

instance Ordered_semiring_0a Rat where {
};

instance Ordered_semiring_1 Rat where {
};

instance Poly_carrier Rat where {
};

class (Dense_order a, Linorder a) => Dense_linorder a where {
};

class (Dense_linorder a, No_bot a,
        No_top a) => Unbounded_dense_linorder a where {
};

class (Field_abs_sgn a, Field_char_0 a, Unbounded_dense_linorder a,
        Linordered_idom a) => Linordered_field a where {
};

instance Dense_linorder Rat where {
};

instance Unbounded_dense_linorder Rat where {
};

instance Linordered_field Rat where {
};

class (Conjugate a, Ring a) => Conjugatable_ring a where {
};

instance Conjugatable_ring Rat where {
};

class (Conjugatable_ring a, Field a) => Conjugatable_field a where {
};

instance Conjugatable_field Rat where {
};

class (Linordered_field a) => Archimedean_field a where {
};

class (Poly_carrier a) => Large_ordered_semiring_1 a where {
};

class (Archimedean_field a,
        Large_ordered_semiring_1 a) => Floor_ceiling a where {
  floor :: a -> Int;
};

floor_rat :: Rat -> Int;
floor_rat p = let {
                a = quotient_of p;
              } in (case a of {
                     (aa, b) -> divide_int aa b;
                   });

instance Archimedean_field Rat where {
};

instance Large_ordered_semiring_1 Rat where {
};

instance Floor_ceiling Rat where {
  floor = floor_rat;
};

class (Conjugatable_ring a,
        Ordered_comm_monoid_add a) => Conjugatable_ordered_ring a where {
};

instance Conjugatable_ordered_ring Rat where {
};

class (Conjugatable_field a,
        Conjugatable_ordered_ring a) => Conjugatable_ordered_field a where {
};

instance Conjugatable_ordered_field Rat where {
};

class (Conjugatable_ordered_field a,
        Linordered_idom a) => Trivial_conjugatable_ordered_field a where {
};

instance Trivial_conjugatable_ordered_field Rat where {
};

cCons :: forall a. (Zero a, Eq a) => a -> [a] -> [a];
cCons x xs = (if null xs && x == zero then [] else x : xs);

plus_coeffs :: forall a. (Comm_monoid_add a, Eq a) => [a] -> [a] -> [a];
plus_coeffs xs [] = xs;
plus_coeffs [] (v : va) = v : va;
plus_coeffs (x : xs) (y : ys) = cCons (plus x y) (plus_coeffs xs ys);

newtype Poly a = Poly [a];

coeffs :: forall a. (Zero a) => Poly a -> [a];
coeffs (Poly x) = x;

plus_poly :: forall a. (Comm_monoid_add a, Eq a) => Poly a -> Poly a -> Poly a;
plus_poly p q = Poly (plus_coeffs (coeffs p) (coeffs q));

instance (Comm_monoid_add a, Eq a) => Plus (Poly a) where {
  plus = plus_poly;
};

zero_poly :: forall a. (Zero a) => Poly a;
zero_poly = Poly [];

instance (Zero a) => Zero (Poly a) where {
  zero = zero_poly;
};

instance (Comm_monoid_add a, Eq a) => Semigroup_add (Poly a) where {
};

instance (Comm_monoid_add a, Eq a) => Monoid_add (Poly a) where {
};

newtype Mat_impl a = Abs_mat_impl (Nat, (Nat, IArray.IArray (IArray.IArray a)));

newtype Mat a = Mat_impl (Mat_impl a);

newtype Vec_impl a = Abs_vec_impl (Nat, IArray.IArray a);

newtype Vec a = Vec_impl (Vec_impl a);

newtype Proper_base = Abs_proper_base Int;

data Factor_tree a = Factor_Leaf a (Poly Int)
  | Factor_Node a (Factor_tree a) (Factor_tree a);

data Arith_ops_record a =
  Arith_Ops_Record a a (a -> a -> a) (a -> a -> a) (a -> a -> a) (a -> a)
    (a -> a -> a) (a -> a) (a -> a -> a) (a -> a) (a -> a) (Int -> a) (a -> Int)
    (a -> Bool);

newtype X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a =
  Abs_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option
  (Maybe (Nat, (Nat, IArray.IArray (IArray.IArray a))));

hd :: forall a. [a] -> a;
hd (x21 : x22) = x21;

get_nth_i :: forall a. ([a], [a]) -> a;
get_nth_i ba = hd (snd ba);

g_i :: ([(Vec Rat, Rat)], [(Vec Rat, Rat)]) -> Vec Rat;
g_i gr = fst (get_nth_i gr);

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

get_nth_im1 :: forall a. ([a], [a]) -> a;
get_nth_im1 ba = hd (fst ba);

g_im1 :: ([(Vec Rat, Rat)], [(Vec Rat, Rat)]) -> Vec Rat;
g_im1 gr = fst (get_nth_im1 gr);

last :: forall a. [a] -> a;
last (x : xs) = (if null xs then x else last xs);

sub :: forall a. IArray.IArray a -> Nat -> a;
sub asa n = IArray.sub (asa, integer_of_nat n);

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

of_fun :: forall a. (Nat -> a) -> Nat -> IArray.IArray a;
of_fun f n =
  (let x = (integer_of_nat n,
             f . nat_of_integer) in (IArray.array (snd x) (fst x)));

mat_of_fun :: forall a. Nat -> Nat -> ((Nat, Nat) -> a) -> Mat_impl a;
mat_of_fun xc xd xe =
  Abs_mat_impl (xc, (xd, of_fun (\ i -> of_fun (\ j -> xe (i, j)) xd) xc));

mat :: forall a. Nat -> Nat -> ((Nat, Nat) -> a) -> Mat a;
mat nr nc f = Mat_impl (mat_of_fun nr nc f);

vec_of_fun :: forall a. Nat -> (Nat -> a) -> Vec_impl a;
vec_of_fun xb xc = Abs_vec_impl (xb, of_fun xc xb);

vec :: forall a. Nat -> (Nat -> a) -> Vec a;
vec n f = Vec_impl (vec_of_fun n f);

of_int :: Int -> Rat;
of_int a = Frct (a, one_int);

member :: forall a. (Eq a) => [a] -> a -> Bool;
member [] y = False;
member (x : xs) y = x == y || member xs y;

sum_list :: forall a. (Monoid_add a) => [a] -> a;
sum_list xs = foldr plus xs zero;

int_times_rat :: Int -> Rat -> Rat;
int_times_rat i x = Frct (case quotient_of x of {
                           (n, d) -> normalize (times_int i n, d);
                         });

rep_vec_impl :: forall a. Vec_impl a -> (Nat, IArray.IArray a);
rep_vec_impl (Abs_vec_impl x) = x;

vec_index_impl :: forall a. Vec_impl a -> Nat -> a;
vec_index_impl xa = (case rep_vec_impl xa of {
                      (_, a) -> sub a;
                    });

vec_index :: forall a. Vec a -> Nat -> a;
vec_index (Vec_impl v) i = vec_index_impl v i;

dim_vec_impl :: forall a. Vec_impl a -> Nat;
dim_vec_impl xa = fst (rep_vec_impl xa);

dim_vec :: forall a. Vec a -> Nat;
dim_vec (Vec_impl v) = dim_vec_impl v;

scalar_prod_int_rat :: Vec Int -> Vec Rat -> Rat;
scalar_prod_int_rat v w =
  sum_list
    (map (\ i -> int_times_rat (vec_index v i) (vec_index w i))
      (upt zero_nat (dim_vec v)));

mu_ij :: Vec Int -> (Vec Rat, Rat) -> Rat;
mu_ij fi gj_norm = (case gj_norm of {
                     (gj, a) -> divide_rat (scalar_prod_int_rat fi gj) a;
                   });

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

length :: forall a. IArray.IArray a -> Nat;
length asa = nat_of_integer (IArray.lengthIArray asa);

list_of :: forall a. IArray.IArray a -> [a];
list_of asa = map (sub asa) (upt zero_nat (length asa));

numeral :: forall a. (Numeral a) => Num -> a;
numeral (Bit1 n) = let {
                     m = numeral n;
                   } in plus (plus m m) one;
numeral (Bit0 n) = let {
                     m = numeral n;
                   } in plus m m;
numeral One = one;

floor_ceil :: forall a. (Floor_ceiling a) => a -> Int;
floor_ceil x = floor (plus x (divide one (numeral (Bit0 One))));

inc_i :: forall a. ([a], [a]) -> ([a], [a]);
inc_i ba = (case ba of {
             (b, a) -> (hd a : b, tl a);
           });

increase_i ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
increase_i state = (case state of {
                     (i, (f, g)) -> (suc i, (inc_i f, inc_i g));
                   });

sqnorm_g_i :: ([(Vec Rat, Rat)], [(Vec Rat, Rat)]) -> Rat;
sqnorm_g_i gr = snd (get_nth_i gr);

partition :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
partition p [] = ([], []);
partition p (x : xs) =
  (case partition p xs of {
    (yes, no) -> (if p x then (x : yes, no) else (yes, x : no));
  });

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

rep_mat_impl ::
  forall a. Mat_impl a -> (Nat, (Nat, IArray.IArray (IArray.IArray a)));
rep_mat_impl (Abs_mat_impl x) = x;

dim_col_impl :: forall a. Mat_impl a -> Nat;
dim_col_impl xa = fst (snd (rep_mat_impl xa));

dim_col :: forall a. Mat a -> Nat;
dim_col (Mat_impl m) = dim_col_impl m;

dim_row_impl :: forall a. Mat_impl a -> Nat;
dim_row_impl xa = fst (rep_mat_impl xa);

dim_row :: forall a. Mat a -> Nat;
dim_row (Mat_impl m) = dim_row_impl m;

map_vec :: forall a b. (a -> b) -> Vec a -> Vec b;
map_vec f v = vec (dim_vec v) (\ i -> f (vec_index v i));

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

zero_vec :: forall a. (Zero a) => Nat -> Vec a;
zero_vec n = vec n (\ _ -> zero);

of_list_repr :: forall a. ([a], [a]) -> [a];
of_list_repr ba = reverse (fst ba) ++ snd ba;

plus_vec :: forall a. (Plus a) => Vec a -> Vec a -> Vec a;
plus_vec v_1 v_2 =
  vec (dim_vec v_2) (\ i -> plus (vec_index v_1 i) (vec_index v_2 i));

scalar_prod :: forall a. (Semiring_0 a) => Vec a -> Vec a -> a;
scalar_prod v w =
  sum_list
    (map (\ i -> times (vec_index v i) (vec_index w i))
      (upt zero_nat (dim_vec w)));

smult_vec :: forall a. (Times a) => a -> Vec a -> Vec a;
smult_vec a v = vec (dim_vec v) (\ i -> times a (vec_index v i));

adjuster_triv ::
  forall a.
    (Trivial_conjugatable_ordered_field a) => Nat ->
        Vec a -> [(Vec a, a)] -> Vec a;
adjuster_triv n w [] = zero_vec n;
adjuster_triv n w ((u, nu) : us) =
  plus_vec (smult_vec (divide (uminus (scalar_prod w u)) nu) u)
    (adjuster_triv n w us);

list_of_vec_impl :: forall a. Vec_impl a -> [a];
list_of_vec_impl xa = (case rep_vec_impl xa of {
                        (_, a) -> list_of a;
                      });

list_of_vec :: forall a. Vec a -> [a];
list_of_vec (Vec_impl v) = list_of_vec_impl v;

sq_norm_vec :: forall a. (Conjugate a, Monoid_add a, Times a) => Vec a -> a;
sq_norm_vec v = sum_list (map (\ x -> times x (conjugate x)) (list_of_vec v));

gram_schmidt_sub_triv ::
  forall a.
    (Trivial_conjugatable_ordered_field a) => Nat ->
        [(Vec a, a)] -> [Vec a] -> [(Vec a, a)];
gram_schmidt_sub_triv n us [] = us;
gram_schmidt_sub_triv n us (w : ws) =
  let {
    u = plus_vec (adjuster_triv n w us) w;
  } in gram_schmidt_sub_triv n ((u, sq_norm_vec u) : us) ws;

gram_schmidt_triv ::
  forall a.
    (Trivial_conjugatable_ordered_field a) => Nat -> [Vec a] -> [(Vec a, a)];
gram_schmidt_triv n ws = reverse (gram_schmidt_sub_triv n [] ws);

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

minus_vec :: forall a. (Minus a) => Vec a -> Vec a -> Vec a;
minus_vec v_1 v_2 =
  vec (dim_vec v_2) (\ i -> minus (vec_index v_1 i) (vec_index v_2 i));

update_i :: forall a. ([a], [a]) -> a -> ([a], [a]);
update_i ba x = (fst ba, x : tl (snd ba));

basis_reduction_add_row_main ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    Vec Int ->
      Rat ->
        ((Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))),
          Int);
basis_reduction_add_row_main (i, (f, g)) fj mu =
  let {
    c = floor_ceil mu;
  } in (if equal_int c zero_int then ((i, (f, g)), c)
         else let {
                fi = minus_vec (get_nth_i f) (smult_vec c fj);
                fa = update_i f fi;
              } in ((i, (fa, g)), c));

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

basis_reduction_add_row_i_im1 ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    ((Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))),
      Rat);
basis_reduction_add_row_i_im1 state =
  (case state of {
    (_, (f, g)) ->
      let {
        mu = mu_ij (get_nth_i f) (get_nth_im1 g);
        fj = get_nth_im1 f;
      } in map_prod id (\ c -> minus_rat mu (of_int c))
             (basis_reduction_add_row_main state fj mu);
  });

update_im1 :: forall a. ([a], [a]) -> a -> ([a], [a]);
update_im1 ba x = (x : tl (fst ba), snd ba);

dec_i :: forall a. ([a], [a]) -> ([a], [a]);
dec_i ba = (case ba of {
             (b, a) -> (tl b, hd b : a);
           });

basis_reduction_swap ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    Rat ->
      (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_swap (i, (f, g)) mu =
  let {
    gi = g_i g;
    gim1 = g_im1 g;
    fi = get_nth_i f;
    fim1 = get_nth_im1 f;
    new_gim1 = plus_vec gi (smult_vec mu gim1);
    norm_gim1 = sq_norm_vec new_gim1;
    new_gi =
      minus_vec gim1
        (smult_vec (divide_rat (scalar_prod_int_rat fim1 new_gim1) norm_gim1)
          new_gim1);
    norm_gi = sq_norm_vec new_gi;
    ga = dec_i (update_im1 (update_i g (new_gi, norm_gi))
                 (new_gim1, norm_gim1));
    fa = dec_i (update_im1 (update_i f fim1) fi);
  } in (minus_nat i one_nat, (fa, ga));

sqnorm_g_im1 :: ([(Vec Rat, Rat)], [(Vec Rat, Rat)]) -> Rat;
sqnorm_g_im1 gr = snd (get_nth_im1 gr);

basis_reduction_step ::
  Rat ->
    (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
      (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_step alpha state =
  (if equal_nat (fst state) zero_nat then increase_i state
    else (case basis_reduction_add_row_i_im1 state of {
           (statea, mu) ->
             (case statea of {
               (_, (_, g)) ->
                 (if less_rat (times_rat alpha (sqnorm_g_i g)) (sqnorm_g_im1 g)
                   then basis_reduction_swap statea mu else increase_i statea);
             });
         }));

basis_reduction_main ::
  Rat ->
    Nat ->
      (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
        (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_main alpha m state =
  (case state of {
    (i, (_, _)) ->
      (if less_nat i m
        then basis_reduction_main alpha m (basis_reduction_step alpha state)
        else state);
  });

basis_reduction_part_1 ::
  Nat ->
    Rat ->
      [Vec Int] ->
        (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_part_1 n alpha f =
  let {
    m = size_list f;
    g = gram_schmidt_triv n (map (map_vec of_int) f);
    fr = ([], f);
    gr = ([], g);
  } in basis_reduction_main alpha m (zero_nat, (fr, gr));

weakly_reduce_basis :: Nat -> Rat -> [Vec Int] -> ([Vec Int], [Vec Rat]);
weakly_reduce_basis n alpha f =
  (((of_list_repr . fst) . snd) (basis_reduction_part_1 n alpha f),
    (((map fst . of_list_repr) . snd) . snd)
      (basis_reduction_part_1 n alpha f));

short_vector :: Rat -> [Vec Int] -> Vec Int;
short_vector alpha f =
  (hd . fst) (weakly_reduce_basis (dim_vec (hd f)) alpha f);

list_update :: forall a. [a] -> Nat -> a -> [a];
list_update [] i y = [];
list_update (x : xs) i y =
  (if equal_nat i zero_nat then y : xs
    else x : list_update xs (minus_nat i one_nat) y);

index_mat_impl :: forall a. Mat_impl a -> (Nat, Nat) -> a;
index_mat_impl xa =
  (case rep_mat_impl xa of {
    (nr, (_, m)) ->
      (\ (i, j) ->
        (if less_nat i nr then sub (sub m i) j
          else sub (IArray.listIArray (nth [] (minus_nat i nr))) j));
  });

index_mat :: forall a. Mat a -> (Nat, Nat) -> a;
index_mat (Mat_impl m) ij = index_mat_impl m ij;

monom :: forall a. (Zero a, Eq a) => a -> Nat -> Poly a;
monom a n = Poly (if a == zero then [] else replicate n zero ++ [a]);

pCons :: forall a. (Zero a, Eq a) => a -> Poly a -> Poly a;
pCons a p = Poly (cCons a (coeffs p));

smult ::
  forall a.
    (Eq a, Comm_semiring_0 a,
      Semiring_no_zero_divisors a) => a -> Poly a -> Poly a;
smult a p = Poly (if a == zero then [] else map (times a) (coeffs p));

all_interval_int :: (Int -> Bool) -> Int -> Int -> Bool;
all_interval_int p i j =
  less_int j i || p i && all_interval_int p (plus_int i one_int) j;

dvd :: forall a. (Semidom_modulo a, Eq a) => a -> a -> Bool;
dvd a b = modulo b a == zero;

prime_int :: Int -> Bool;
prime_int p =
  less_int one_int p &&
    all_interval_int (\ n -> not (dvd n p)) (plus_int one_int one_int)
      (minus_int p one_int);

all_interval_nat :: (Nat -> Bool) -> Nat -> Nat -> Bool;
all_interval_nat p i j = less_eq_nat j i || p i && all_interval_nat p (suc i) j;

prime_nat :: Nat -> Bool;
prime_nat p =
  less_nat one_nat p && all_interval_nat (\ n -> not (dvd n p)) (suc one_nat) p;

rep_proper_base :: Proper_base -> Int;
rep_proper_base (Abs_proper_base x) = x;

get_base :: Proper_base -> Int;
get_base x = rep_proper_base x;

square_base :: Proper_base -> Proper_base;
square_base xa =
  Abs_proper_base (times_int (rep_proper_base xa) (rep_proper_base xa));

log_main :: Proper_base -> Int -> (Nat, Int);
log_main b x =
  (if less_int x (get_base b) then (zero_nat, one_int)
    else (case log_main (square_base b) x of {
           (z, bz) -> let {
                        l = times_nat (nat_of_integer (2 :: Integer)) z;
                        bz1 = times_int bz (get_base b);
                      } in (if less_int x bz1 then (l, bz) else (suc l, bz1));
         }));

degree :: forall a. (Zero a) => Poly a -> Nat;
degree p = minus_nat (size_list (coeffs p)) one_nat;

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat m n =
  let {
    k = integer_of_nat m;
    l = integer_of_nat n;
  } in map_prod nat_of_integer nat_of_integer
         (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else divMod ( k ) ( l )));

into_base :: Int -> Proper_base;
into_base xa =
  Abs_proper_base
    (if less_eq_int (Int_of_integer (2 :: Integer)) xa then xa
      else Int_of_integer (2 :: Integer));

mat_of_rows :: forall a. Nat -> [Vec a] -> Mat a;
mat_of_rows n rs = mat (size_list rs) n (\ (i, a) -> vec_index (nth rs i) a);

vec_of_list_impl :: forall a. [a] -> Vec_impl a;
vec_of_list_impl xa = Abs_vec_impl (size_list xa, IArray.listIArray xa);

vec_of_list :: forall a. [a] -> Vec a;
vec_of_list v = Vec_impl (vec_of_list_impl v);

sq_norm_poly :: forall a. (Conjugate a, Monoid_add a, Times a) => Poly a -> a;
sq_norm_poly p = sum_list (map (\ a -> times a (conjugate a)) (coeffs p));

fold_coeffs :: forall a b. (Zero a) => (a -> b -> b) -> Poly a -> b -> b;
fold_coeffs f p = foldr f (coeffs p);

content :: forall a. (Semiring_gcd a) => Poly a -> a;
content p = fold_coeffs gcda p zero;

m :: Int -> Int -> Int;
m m x = modulo_int x m;

strip_while :: forall a. (a -> Bool) -> [a] -> [a];
strip_while p = (reverse . dropWhile p) . reverse;

map_poly :: forall b a. (Zero b, Zero a, Eq a) => (b -> a) -> Poly b -> Poly a;
map_poly f p = Poly (strip_while (\ a -> zero == a) (map f (coeffs p)));

log_ceiling :: Int -> Int -> Nat;
log_ceiling b x = (case log_main (into_base b) x of {
                    (y, by) -> (if equal_int x by then y else suc y);
                  });

transpose_mat :: forall a. Mat a -> Mat a;
transpose_mat a = mat (dim_col a) (dim_row a) (\ (i, j) -> index_mat a (j, i));

no_leading :: forall a. (a -> Bool) -> [a] -> Bool;
no_leading p xs = (if not (null xs) then not (p (hd xs)) else True);

new_zero :: forall a. (Zero a) => a;
new_zero = zero;

max_list :: forall a. (Ord a) => [a] -> a;
max_list (x : y : xs) = max x (max_list (y : xs));
max_list [x] = x;

linf_norm_poly :: forall a. (Abs a, Zero a, Ord a) => Poly a -> a;
linf_norm_poly f = max_list (map absa (coeffs f) ++ [new_zero]);

euclid_ext_aux ::
  forall a.
    (Euclidean_ring_gcd a, Eq a) => a -> a -> a -> a -> a -> a -> ((a, a), a);
euclid_ext_aux sa s ta t ra r =
  (if r == zero then let {
                       c = divide one (unit_factor ra);
                     } in ((times sa c, times ta c), normalizea ra)
    else let {
           q = divide ra r;
         } in euclid_ext_aux s (minus sa (times q s)) t (minus ta (times q t)) r
                (modulo ra r));

bezout_coefficients ::
  forall a. (Euclidean_ring_gcd a, Eq a) => a -> a -> (a, a);
bezout_coefficients a b = fst (euclid_ext_aux one zero zero one a b);

inverse_mod :: Int -> Int -> Int;
inverse_mod x m = fst (bezout_coefficients x m);

mp :: Int -> Poly Int -> Poly Int;
mp ma = map_poly (m ma);

int_of_uint32 :: Uint32.Word32 -> Int;
int_of_uint32 x = Int_of_integer (Prelude.toInteger x);

uint32_of_int :: Int -> Uint32.Word32;
uint32_of_int i = (Prelude.fromInteger (integer_of_int i) :: Uint32.Word32);

int_of_uint64 :: Uint64.Word64 -> Int;
int_of_uint64 x = Int_of_integer (Prelude.toInteger x);

uint64_of_int :: Int -> Uint64.Word64;
uint64_of_int i = (Prelude.fromInteger (integer_of_int i) :: Uint64.Word64);

divmod_int :: Int -> Int -> (Int, Int);
divmod_int m n =
  map_prod Int_of_integer Int_of_integer
    (divmod_integer (integer_of_int m) (integer_of_int n));

nth_default :: forall a. a -> [a] -> Nat -> a;
nth_default dflt xs n = (if less_nat n (size_list xs) then nth xs n else dflt);

coeff :: forall a. (Zero a) => Poly a -> Nat -> a;
coeff p = nth_default zero (coeffs p);

minus_poly_rev_list :: forall a. (Group_add a) => [a] -> [a] -> [a];
minus_poly_rev_list (x : xs) (y : ys) = minus x y : minus_poly_rev_list xs ys;
minus_poly_rev_list xs [] = xs;
minus_poly_rev_list [] (y : ys) = [];

pseudo_mod_main_list ::
  forall a. (Eq a, Comm_ring_1 a) => a -> [a] -> [a] -> Nat -> [a];
pseudo_mod_main_list lc r d n =
  (if equal_nat n zero_nat then r
    else let {
           rr = map (times lc) r;
           a = hd r;
           rrr = tl (if a == zero then rr
                      else minus_poly_rev_list rr (map (times a) d));
         } in pseudo_mod_main_list lc rrr d (minus_nat n one_nat));

pseudo_mod_list :: forall a. (Eq a, Comm_ring_1 a) => [a] -> [a] -> [a];
pseudo_mod_list p q =
  (if null q then p
    else let {
           rq = reverse q;
           a = pseudo_mod_main_list (hd rq) (reverse p) rq
                 (minus_nat (plus_nat one_nat (size_list p)) (size_list q));
         } in reverse a);

poly_of_list :: forall a. (Comm_monoid_add a, Eq a) => [a] -> Poly a;
poly_of_list asa = Poly (strip_while (\ a -> zero == a) asa);

pseudo_mod ::
  forall a.
    (Eq a, Comm_ring_1 a,
      Semiring_1_no_zero_divisors a) => Poly a -> Poly a -> Poly a;
pseudo_mod f g = poly_of_list (pseudo_mod_list (coeffs f) (coeffs g));

poly_of_vec :: forall a. (Comm_monoid_add a, Eq a) => Vec a -> Poly a;
poly_of_vec v =
  let {
    d = dim_vec v;
  } in sum_list
         (map (\ i -> monom (vec_index v (minus_nat d (suc i))) i)
           (upt zero_nat d));

rev_upt_aux :: Nat -> Nat -> [Nat] -> [Nat];
rev_upt_aux i j js =
  (if less_eq_nat i j then js else rev_upt_aux i (suc j) (j : js));

rev_upt :: Nat -> Nat -> [Nat];
rev_upt i j = rev_upt_aux i j [];

equal_poly :: forall a. (Zero a, Eq a) => Poly a -> Poly a -> Bool;
equal_poly p q = coeffs p == coeffs q;

mod_nonneg_pos_int :: Int -> Int -> Int;
mod_nonneg_pos_int x y =
  Int_of_integer (Prelude.mod ( (integer_of_int x) ) ( (integer_of_int y) ));

mult_p :: Int -> Int -> Int -> Int;
mult_p p x y = mod_nonneg_pos_int (times_int x y) p;

power_p :: Int -> Int -> Nat -> Int;
power_p p x n =
  (if equal_nat n zero_nat then one_int
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (d, r) ->
             let {
               rec = power_p p (mult_p p x x) d;
             } in (if equal_nat r zero_nat then rec else mult_p p rec x);
         }));

inverse_p :: Int -> Int -> Int;
inverse_p p x =
  (if equal_int x zero_int then zero_int
    else power_p p x (nat (minus_int p (Int_of_integer (2 :: Integer)))));

pseudo_divmod_main_list ::
  forall a.
    (Eq a, Comm_ring_1 a) => a -> [a] -> [a] -> [a] -> Nat -> ([a], [a]);
pseudo_divmod_main_list lc q r d n =
  (if equal_nat n zero_nat then (q, r)
    else let {
           rr = map (times lc) r;
           a = hd r;
           qqq = cCons a (map (times lc) q);
           rrr = tl (if a == zero then rr
                      else minus_poly_rev_list rr (map (times a) d));
         } in pseudo_divmod_main_list lc qqq rrr d (minus_nat n one_nat));

pseudo_divmod_list ::
  forall a. (Eq a, Comm_ring_1 a) => [a] -> [a] -> ([a], [a]);
pseudo_divmod_list p q =
  (if null q then ([], p)
    else let {
           rq = reverse q;
         } in (case pseudo_divmod_main_list (hd rq) [] (reverse p) rq
                      (minus_nat (plus_nat one_nat (size_list p)) (size_list q))
                of {
                (qu, re) -> (qu, reverse re);
              }));

pseudo_divmod ::
  forall a. (Eq a, Comm_ring_1 a) => Poly a -> Poly a -> (Poly a, Poly a);
pseudo_divmod f g =
  map_prod poly_of_list poly_of_list (pseudo_divmod_list (coeffs f) (coeffs g));

pdivmod2 :: Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
pdivmod2 m f g =
  (if equal_poly (mp m g) zero_poly then (zero_poly, f)
    else let {
           ilc = inverse_p m (coeff (mp m g) (degree (mp m g)));
           h = smult ilc (mp m g);
           a = pseudo_divmod (mp m f) (mp m h);
         } in (case a of {
                (q, aa) -> (smult ilc q, aa);
              }));

dvdm :: Int -> Poly Int -> Poly Int -> Bool;
dvdm m g f =
  (if prime_int m then equal_poly (mp m (snd (pdivmod2 m f g))) zero_poly
    else (error :: forall a. String -> (() -> a) -> a)
           "dvdm error: m is not a prime number" (\ _ -> dvdm m g f));

swap :: forall a b. (a, b) -> (b, a);
swap p = (snd p, fst p);

rep_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option ::
  forall a.
    X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a ->
      Maybe (Nat, (Nat, IArray.IArray (IArray.IArray a)));
rep_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option
  (Abs_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option x) =
  x;

sel21 ::
  forall a.
    X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a ->
      Mat_impl a;
sel21 xa =
  Abs_mat_impl
    (case rep_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option
            xa
      of {
      Nothing -> rep_mat_impl (error "undefined");
      Just x2 -> x2;
    });

dis1 ::
  forall a.
    X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a ->
      Bool;
dis1 xa =
  (case rep_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option
          xa
    of {
    Nothing -> True;
    Just _ -> False;
  });

rep_isom ::
  forall a.
    X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a ->
      Maybe (Mat_impl a);
rep_isom x = (if dis1 x then Nothing else Just (sel21 x));

mat_of_rows_list_impl_aux ::
  forall a.
    Nat ->
      [[a]] ->
        X_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option a;
mat_of_rows_list_impl_aux xb xc =
  Abs_x_a_mat_impl_option_x_x_x_a_iarray_iarray_nat_prod_nat_prod_option
    (if all (\ r -> equal_nat (size_list r) xb) xc
      then Just (size_list xc,
                  (xb, IArray.listIArray (map IArray.listIArray xc)))
      else Nothing);

mat_of_rows_list_impl :: forall a. Nat -> [[a]] -> Maybe (Mat_impl a);
mat_of_rows_list_impl x1 x2 = rep_isom (mat_of_rows_list_impl_aux x1 x2);

mat_of_rows_list :: forall a. Nat -> [[a]] -> Mat a;
mat_of_rows_list nc vs =
  (case mat_of_rows_list_impl nc vs of {
    Nothing -> mat_of_rows nc (map (\ v -> vec nc (nth v)) vs);
    Just a -> Mat_impl a;
  });

binary_power :: forall a. (Monoid_mult a) => a -> Nat -> a;
binary_power x n =
  (if equal_nat n zero_nat then one
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (d, r) -> let {
                       rec = binary_power (times x x) d;
                     } in (if equal_nat r zero_nat then rec else times rec x);
         }));

of_nat :: forall a. (Semiring_1 a) => Nat -> a;
of_nat n =
  (if equal_nat n zero_nat then zero
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (m, q) -> let {
                       ma = times (numeral (Bit0 One)) (of_nat m);
                     } in (if equal_nat q zero_nat then ma else plus ma one);
         }));

ceiling :: forall a. (Floor_ceiling a) => a -> Int;
ceiling x = uminus_int (floor (uminus x));

start_value :: Int -> Nat -> Int;
start_value n p =
  binary_power (Int_of_integer (2 :: Integer))
    (nat (ceiling
           (divide_rat (of_nat (log_ceiling (Int_of_integer (2 :: Integer)) n))
             (of_nat p))));

uminus_poly :: forall a. (Ab_group_add a) => Poly a -> Poly a;
uminus_poly p = Poly (map uminus (coeffs p));

minus_poly :: forall a. (Ab_group_add a, Eq a) => Poly a -> Poly a -> Poly a;
minus_poly p q = plus_poly p (uminus_poly q);

div_mod_int_poly :: Poly Int -> Poly Int -> Maybe (Poly Int, Poly Int);
div_mod_int_poly p q =
  (if equal_poly q zero_poly then Nothing
    else let {
           n = degree q;
           _ = coeff q n;
         } in fold_coeffs
                (\ a b ->
                  (case b of {
                    Nothing -> Nothing;
                    Just (s, r) ->
                      let {
                        ar = pCons a r;
                      } in (case divmod_int (coeff ar (degree q))
                                   (coeff q (degree q))
                             of {
                             (ba, m) ->
                               (if equal_int m zero_int
                                 then Just
(pCons ba s, minus_poly ar (smult ba q))
                                 else Nothing);
                           });
                  }))
                p (Just (zero_poly, zero_poly)));

div_int_poly :: Poly Int -> Poly Int -> Maybe (Poly Int);
div_int_poly p q =
  (case div_mod_int_poly p q of {
    Nothing -> Nothing;
    Just (d, m) -> (if equal_poly m zero_poly then Just d else Nothing);
  });

basis_reduction_add_row_i_all_main ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    [Vec Int] ->
      [(Vec Rat, Rat)] ->
        (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_add_row_i_all_main state (fj : fjs) (gj : gjs) =
  (case state of {
    (_, (f, _)) ->
      let {
        fi = get_nth_i f;
      } in basis_reduction_add_row_i_all_main
             (fst (basis_reduction_add_row_main state fj (mu_ij fi gj))) fjs
             gjs;
  });
basis_reduction_add_row_i_all_main state [] uv = state;
basis_reduction_add_row_i_all_main state uu [] = state;

basis_reduction_add_row_i_all ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_add_row_i_all state =
  (case state of {
    (_, (f, g)) -> let {
                     fjs = fst f;
                     a = fst g;
                   } in basis_reduction_add_row_i_all_main state fjs a;
  });

basis_reduction_part_2_main ::
  (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)]))) ->
    (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_part_2_main (i, (f, g)) =
  (if equal_nat i zero_nat then (i, (f, g))
    else (case basis_reduction_add_row_i_all
                 (minus_nat i one_nat, (dec_i f, dec_i g))
           of {
           (_, (fa, ga)) ->
             basis_reduction_part_2_main (minus_nat i one_nat, (fa, ga));
         }));

basis_reduction_part_2 ::
  Nat ->
    Rat ->
      [Vec Int] ->
        (Nat, (([Vec Int], [Vec Int]), ([(Vec Rat, Rat)], [(Vec Rat, Rat)])));
basis_reduction_part_2 n alpha f =
  basis_reduction_part_2_main (basis_reduction_part_1 n alpha f);

strictly_reduce_basis :: Nat -> Rat -> [Vec Int] -> ([Vec Int], [Vec Rat]);
strictly_reduce_basis n alpha f =
  (((of_list_repr . fst) . snd) (basis_reduction_part_2 n alpha f),
    (((map fst . of_list_repr) . snd) . snd)
      (basis_reduction_part_2 n alpha f));

primitive_part :: forall a. (Semiring_gcd a, Eq a) => Poly a -> Poly a;
primitive_part p = map_poly (\ x -> divide x (content p)) p;

primes_1000 :: [Nat];
primes_1000 =
  [nat_of_integer (2 :: Integer), nat_of_integer (3 :: Integer),
    nat_of_integer (5 :: Integer), nat_of_integer (7 :: Integer),
    nat_of_integer (11 :: Integer), nat_of_integer (13 :: Integer),
    nat_of_integer (17 :: Integer), nat_of_integer (19 :: Integer),
    nat_of_integer (23 :: Integer), nat_of_integer (29 :: Integer),
    nat_of_integer (31 :: Integer), nat_of_integer (37 :: Integer),
    nat_of_integer (41 :: Integer), nat_of_integer (43 :: Integer),
    nat_of_integer (47 :: Integer), nat_of_integer (53 :: Integer),
    nat_of_integer (59 :: Integer), nat_of_integer (61 :: Integer),
    nat_of_integer (67 :: Integer), nat_of_integer (71 :: Integer),
    nat_of_integer (73 :: Integer), nat_of_integer (79 :: Integer),
    nat_of_integer (83 :: Integer), nat_of_integer (89 :: Integer),
    nat_of_integer (97 :: Integer), nat_of_integer (101 :: Integer),
    nat_of_integer (103 :: Integer), nat_of_integer (107 :: Integer),
    nat_of_integer (109 :: Integer), nat_of_integer (113 :: Integer),
    nat_of_integer (127 :: Integer), nat_of_integer (131 :: Integer),
    nat_of_integer (137 :: Integer), nat_of_integer (139 :: Integer),
    nat_of_integer (149 :: Integer), nat_of_integer (151 :: Integer),
    nat_of_integer (157 :: Integer), nat_of_integer (163 :: Integer),
    nat_of_integer (167 :: Integer), nat_of_integer (173 :: Integer),
    nat_of_integer (179 :: Integer), nat_of_integer (181 :: Integer),
    nat_of_integer (191 :: Integer), nat_of_integer (193 :: Integer),
    nat_of_integer (197 :: Integer), nat_of_integer (199 :: Integer),
    nat_of_integer (211 :: Integer), nat_of_integer (223 :: Integer),
    nat_of_integer (227 :: Integer), nat_of_integer (229 :: Integer),
    nat_of_integer (233 :: Integer), nat_of_integer (239 :: Integer),
    nat_of_integer (241 :: Integer), nat_of_integer (251 :: Integer),
    nat_of_integer (257 :: Integer), nat_of_integer (263 :: Integer),
    nat_of_integer (269 :: Integer), nat_of_integer (271 :: Integer),
    nat_of_integer (277 :: Integer), nat_of_integer (281 :: Integer),
    nat_of_integer (283 :: Integer), nat_of_integer (293 :: Integer),
    nat_of_integer (307 :: Integer), nat_of_integer (311 :: Integer),
    nat_of_integer (313 :: Integer), nat_of_integer (317 :: Integer),
    nat_of_integer (331 :: Integer), nat_of_integer (337 :: Integer),
    nat_of_integer (347 :: Integer), nat_of_integer (349 :: Integer),
    nat_of_integer (353 :: Integer), nat_of_integer (359 :: Integer),
    nat_of_integer (367 :: Integer), nat_of_integer (373 :: Integer),
    nat_of_integer (379 :: Integer), nat_of_integer (383 :: Integer),
    nat_of_integer (389 :: Integer), nat_of_integer (397 :: Integer),
    nat_of_integer (401 :: Integer), nat_of_integer (409 :: Integer),
    nat_of_integer (419 :: Integer), nat_of_integer (421 :: Integer),
    nat_of_integer (431 :: Integer), nat_of_integer (433 :: Integer),
    nat_of_integer (439 :: Integer), nat_of_integer (443 :: Integer),
    nat_of_integer (449 :: Integer), nat_of_integer (457 :: Integer),
    nat_of_integer (461 :: Integer), nat_of_integer (463 :: Integer),
    nat_of_integer (467 :: Integer), nat_of_integer (479 :: Integer),
    nat_of_integer (487 :: Integer), nat_of_integer (491 :: Integer),
    nat_of_integer (499 :: Integer), nat_of_integer (503 :: Integer),
    nat_of_integer (509 :: Integer), nat_of_integer (521 :: Integer),
    nat_of_integer (523 :: Integer), nat_of_integer (541 :: Integer),
    nat_of_integer (547 :: Integer), nat_of_integer (557 :: Integer),
    nat_of_integer (563 :: Integer), nat_of_integer (569 :: Integer),
    nat_of_integer (571 :: Integer), nat_of_integer (577 :: Integer),
    nat_of_integer (587 :: Integer), nat_of_integer (593 :: Integer),
    nat_of_integer (599 :: Integer), nat_of_integer (601 :: Integer),
    nat_of_integer (607 :: Integer), nat_of_integer (613 :: Integer),
    nat_of_integer (617 :: Integer), nat_of_integer (619 :: Integer),
    nat_of_integer (631 :: Integer), nat_of_integer (641 :: Integer),
    nat_of_integer (643 :: Integer), nat_of_integer (647 :: Integer),
    nat_of_integer (653 :: Integer), nat_of_integer (659 :: Integer),
    nat_of_integer (661 :: Integer), nat_of_integer (673 :: Integer),
    nat_of_integer (677 :: Integer), nat_of_integer (683 :: Integer),
    nat_of_integer (691 :: Integer), nat_of_integer (701 :: Integer),
    nat_of_integer (709 :: Integer), nat_of_integer (719 :: Integer),
    nat_of_integer (727 :: Integer), nat_of_integer (733 :: Integer),
    nat_of_integer (739 :: Integer), nat_of_integer (743 :: Integer),
    nat_of_integer (751 :: Integer), nat_of_integer (757 :: Integer),
    nat_of_integer (761 :: Integer), nat_of_integer (769 :: Integer),
    nat_of_integer (773 :: Integer), nat_of_integer (787 :: Integer),
    nat_of_integer (797 :: Integer), nat_of_integer (809 :: Integer),
    nat_of_integer (811 :: Integer), nat_of_integer (821 :: Integer),
    nat_of_integer (823 :: Integer), nat_of_integer (827 :: Integer),
    nat_of_integer (829 :: Integer), nat_of_integer (839 :: Integer),
    nat_of_integer (853 :: Integer), nat_of_integer (857 :: Integer),
    nat_of_integer (859 :: Integer), nat_of_integer (863 :: Integer),
    nat_of_integer (877 :: Integer), nat_of_integer (881 :: Integer),
    nat_of_integer (883 :: Integer), nat_of_integer (887 :: Integer),
    nat_of_integer (907 :: Integer), nat_of_integer (911 :: Integer),
    nat_of_integer (919 :: Integer), nat_of_integer (929 :: Integer),
    nat_of_integer (937 :: Integer), nat_of_integer (941 :: Integer),
    nat_of_integer (947 :: Integer), nat_of_integer (953 :: Integer),
    nat_of_integer (967 :: Integer), nat_of_integer (971 :: Integer),
    nat_of_integer (977 :: Integer), nat_of_integer (983 :: Integer),
    nat_of_integer (991 :: Integer), nat_of_integer (997 :: Integer)];

next_candidates :: Nat -> (Nat, [Nat]);
next_candidates n =
  (if equal_nat n zero_nat then (nat_of_integer (1001 :: Integer), primes_1000)
    else (plus_nat n (nat_of_integer (30 :: Integer)),
           [n, plus_nat n (nat_of_integer (2 :: Integer)),
             plus_nat n (nat_of_integer (6 :: Integer)),
             plus_nat n (nat_of_integer (8 :: Integer)),
             plus_nat n (nat_of_integer (12 :: Integer)),
             plus_nat n (nat_of_integer (18 :: Integer)),
             plus_nat n (nat_of_integer (20 :: Integer)),
             plus_nat n (nat_of_integer (26 :: Integer))]));

next_primes :: Nat -> (Nat, [Nat]);
next_primes n =
  (if equal_nat n zero_nat then next_candidates zero_nat
    else (case next_candidates n of {
           (m, ps) -> (m, filter prime_nat ps);
         }));

find_prime_main :: (Nat -> Bool) -> Nat -> [Nat] -> Nat;
find_prime_main f np ps =
  (case ps of {
    [] -> let {
            a = next_primes np;
          } in (case a of {
                 (aa, b) -> find_prime_main f aa b;
               });
    p : psa -> (if f p then p else find_prime_main f np psa);
  });

find_prime :: (Nat -> Bool) -> Nat;
find_prime f = find_prime_main f zero_nat [];

int_of_nat :: Nat -> Int;
int_of_nat n = Int_of_integer (integer_of_nat n);

divide_poly_main_list ::
  forall a. (Eq a, Idom_divide a) => a -> [a] -> [a] -> [a] -> Nat -> [a];
divide_poly_main_list lc q r d n =
  (if equal_nat n zero_nat then q
    else let {
           cr = hd r;
         } in (if cr == zero
                then divide_poly_main_list lc (cCons cr q) (tl r) d
                       (minus_nat n one_nat)
                else let {
                       a = divide cr lc;
                       qq = cCons a q;
                       rr = minus_poly_rev_list r (map (times a) d);
                     } in (if hd rr == zero
                            then divide_poly_main_list lc qq (tl rr) d
                                   (minus_nat n one_nat)
                            else [])));

divide_poly_list ::
  forall a. (Eq a, Idom_divide a) => Poly a -> Poly a -> Poly a;
divide_poly_list f g =
  let {
    cg = coeffs g;
  } in (if null cg then g
         else let {
                cf = coeffs f;
                cgr = reverse cg;
              } in poly_of_list
                     (divide_poly_main_list (hd cgr) [] (reverse cf) cgr
                       (minus_nat (plus_nat one_nat (size_list cf))
                         (size_list cg))));

list_to_basis :: [[Integer]] -> [Vec Int];
list_to_basis = map (vec_of_list . map Int_of_integer);

vector_to_list :: Vec Int -> [Integer];
vector_to_list = map integer_of_int . list_of_vec;

basis_to_list :: ([Vec Int], [Vec Rat]) -> [[Integer]];
basis_to_list = map vector_to_list . fst;

weak_test :: [[Integer]] -> [[Integer]];
weak_test xs =
  ((basis_to_list .
     weakly_reduce_basis (size_list xs)
       (of_int (Int_of_integer (2 :: Integer)))) .
    list_to_basis)
    xs;

sequences :: forall a b. (Linorder b) => (a -> b) -> [a] -> [[a]];
sequences key (a : b : xs) =
  (if less (key b) (key a) then desc key b [a] xs
    else asc key b (\ ba -> a : ba) xs);
sequences key [] = [[]];
sequences key [v] = [[v]];

asc ::
  forall a b. (Linorder b) => (a -> b) -> a -> ([a] -> [a]) -> [a] -> [[a]];
asc key a f (b : bs) =
  (if not (less (key b) (key a)) then asc key b (f . (\ ba -> a : ba)) bs
    else f [a] : sequences key (b : bs));
asc key a f [] = f [a] : sequences key [];

desc :: forall a b. (Linorder b) => (a -> b) -> a -> [a] -> [a] -> [[a]];
desc key a asa (b : bs) =
  (if less (key b) (key a) then desc key b (a : asa) bs
    else (a : asa) : sequences key (b : bs));
desc key a asa [] = (a : asa) : sequences key [];

merge :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a] -> [a];
merge key (a : asa) (b : bs) =
  (if less (key b) (key a) then b : merge key (a : asa) bs
    else a : merge key asa (b : bs));
merge key [] bs = bs;
merge key (v : va) [] = v : va;

merge_pairs :: forall a b. (Linorder b) => (a -> b) -> [[a]] -> [[a]];
merge_pairs key (a : b : xs) = merge key a b : merge_pairs key xs;
merge_pairs key [] = [];
merge_pairs key [v] = [v];

merge_all :: forall a b. (Linorder b) => (a -> b) -> [[a]] -> [a];
merge_all key [] = [];
merge_all key [x] = x;
merge_all key (v : vb : vc) = merge_all key (merge_pairs key (v : vb : vc));

sort_key :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a];
sort_key key = merge_all key . sequences key;

vec_of_poly_n :: forall a. (Zero a) => Poly a -> Nat -> Vec a;
vec_of_poly_n p n =
  vec n (\ i ->
          (if less_nat i (minus_nat (minus_nat n (degree p)) one_nat) then zero
            else coeff p (minus_nat (minus_nat n i) one_nat)));

sdiv_poly :: forall a. (Eq a, Idom_divide a) => Poly a -> a -> Poly a;
sdiv_poly p a = map_poly (\ c -> divide c a) p;

karatsuba_lower_bound :: Nat;
karatsuba_lower_bound = nat_of_integer (7 :: Integer);

coeffs_minus :: forall a. (Ab_group_add a) => [a] -> [a] -> [a];
coeffs_minus (x : xs) (y : ys) = minus x y : coeffs_minus xs ys;
coeffs_minus xs [] = xs;
coeffs_minus [] (v : va) = map uminus (v : va);

split_at :: forall a. Nat -> [a] -> ([a], [a]);
split_at n (x : xs) =
  (if equal_nat n zero_nat then ([], x : xs)
    else (case split_at (minus_nat n one_nat) xs of {
           (bef, a) -> (x : bef, a);
         }));
split_at n [] = ([], []);

monom_mult :: forall a. (Comm_semiring_1 a) => Nat -> Poly a -> Poly a;
monom_mult n f = Poly (let {
                         xs = coeffs f;
                       } in (if null xs then xs else replicate n zero ++ xs));

karatsuba_main ::
  forall a.
    (Eq a, Comm_ring_1 a,
      Semiring_no_zero_divisors a) => [a] -> Nat -> [a] -> Nat -> Poly a;
karatsuba_main f n g m =
  (if less_eq_nat n karatsuba_lower_bound || less_eq_nat m karatsuba_lower_bound
    then let {
           ff = poly_of_list f;
         } in foldr (\ a p -> plus_poly (smult a ff) (pCons zero p)) g zero_poly
    else let {
           n2 = divide_nat n (nat_of_integer (2 :: Integer));
         } in (if less_nat n2 m
                then (case split_at n2 f of {
                       (f0, f1) ->
                         (case split_at n2 g of {
                           (g0, g1) ->
                             let {
                               p1 = karatsuba_main f1 (minus_nat n n2) g1
                                      (minus_nat m n2);
                               p2 = karatsuba_main (coeffs_minus f1 f0) n2
                                      (coeffs_minus g1 g0) n2;
                               p3 = karatsuba_main f0 n2 g0 n2;
                             } in plus_poly (monom_mult (plus_nat n2 n2) p1)
                                    (plus_poly
                                      (monom_mult n2
(plus_poly (minus_poly p1 p2) p3))
                                      p3);
                         });
                     })
                else (case split_at n2 f of {
                       (f0, f1) ->
                         let {
                           p1 = karatsuba_main f1 (minus_nat n n2) g m;
                           a = karatsuba_main f0 n2 g m;
                         } in plus_poly (monom_mult n2 p1) a;
                     })));

karatsuba_mult_poly ::
  forall a.
    (Eq a, Comm_ring_1 a,
      Semiring_no_zero_divisors a) => Poly a -> Poly a -> Poly a;
karatsuba_mult_poly f g =
  let {
    ff = coeffs f;
    gg = coeffs g;
    n = size_list ff;
    m = size_list gg;
  } in (if less_eq_nat n karatsuba_lower_bound ||
             less_eq_nat m karatsuba_lower_bound
         then (if less_eq_nat n m
                then foldr (\ a p -> plus_poly (smult a g) (pCons zero p)) ff
                       zero_poly
                else foldr (\ a p -> plus_poly (smult a f) (pCons zero p)) gg
                       zero_poly)
         else (if less_eq_nat n m then karatsuba_main gg m ff n
                else karatsuba_main ff n gg m));

factor_node_info :: forall a. Factor_tree a -> a;
factor_node_info (Factor_Leaf i x) = i;
factor_node_info (Factor_Node i l r) = i;

product_factor_tree :: forall a. Int -> Factor_tree a -> Factor_tree (Poly Int);
product_factor_tree p (Factor_Leaf i x) = Factor_Leaf x x;
product_factor_tree p (Factor_Node i l r) =
  let {
    la = product_factor_tree p l;
    ra = product_factor_tree p r;
    f = factor_node_info la;
    g = factor_node_info ra;
    fg = mp p (karatsuba_mult_poly f g);
  } in Factor_Node fg la ra;

mult_p_integer :: Integer -> Integer -> Integer -> Integer;
mult_p_integer p x y = modulo_integer (x * y) p;

power_p_integer :: Integer -> Integer -> Integer -> Integer;
power_p_integer p x n =
  (if n <= (0 :: Integer) then (1 :: Integer)
    else let {
           rec = power_p_integer p (mult_p_integer p x x)
                   ((Data_Bits.shiftrUnbounded :: Integer -> Integer -> Integer)
                     n (1 :: Integer));
         } in (if ((Data_Bits..&.) :: Integer -> Integer -> Integer) n
                    (1 :: Integer) ==
                    (0 :: Integer)
                then rec else mult_p_integer p rec x));

inverse_p_integer :: Integer -> Integer -> Integer;
inverse_p_integer p x =
  (if x == (0 :: Integer) then (0 :: Integer)
    else power_p_integer p x (p - (2 :: Integer)));

uminus_p_integer :: Integer -> Integer -> Integer;
uminus_p_integer p x = (if x == (0 :: Integer) then (0 :: Integer) else p - x);

divide_p_integer :: Integer -> Integer -> Integer -> Integer;
divide_p_integer p x y = mult_p_integer p x (inverse_p_integer p y);

minus_p_integer :: Integer -> Integer -> Integer -> Integer;
minus_p_integer p x y = (if y <= x then x - y else x + p - y);

plus_p_integer :: Integer -> Integer -> Integer -> Integer;
plus_p_integer p x y = let {
                         z = x + y;
                       } in (if p <= z then z - p else z);

finite_field_ops_integer :: Integer -> Arith_ops_record Integer;
finite_field_ops_integer p =
  Arith_Ops_Record (0 :: Integer) (1 :: Integer) (plus_p_integer p)
    (mult_p_integer p) (minus_p_integer p) (uminus_p_integer p)
    (divide_p_integer p) (inverse_p_integer p)
    (\ x y -> (if y == (0 :: Integer) then x else (0 :: Integer)))
    (\ x -> (if x == (0 :: Integer) then (0 :: Integer) else (1 :: Integer)))
    (\ x -> x) integer_of_int Int_of_integer
    (\ x -> (0 :: Integer) <= x && x < p);

modulo_uint64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
modulo_uint64 x y = (if y == (0 :: Uint64.Word64) then x else Prelude.mod x y);

mult_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
mult_p64 p x y = modulo_uint64 (x * y) p;

power_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
power_p64 p x n =
  (if n == (0 :: Uint64.Word64) then (1 :: Uint64.Word64)
    else let {
           rec = power_p64 p (mult_p64 p x x)
                   (Data_Bits.shiftrBounded n (1 :: Integer));
         } in (if n Data_Bits..&. (1 :: Uint64.Word64) == (0 :: Uint64.Word64)
                then rec else mult_p64 p rec x));

inverse_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
inverse_p64 p x =
  (if x == (0 :: Uint64.Word64) then (0 :: Uint64.Word64)
    else power_p64 p x
           (p - (Prelude.fromInteger (2 :: Integer) :: Uint64.Word64)));

uminus_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
uminus_p64 p x =
  (if x == (0 :: Uint64.Word64) then (0 :: Uint64.Word64) else p - x);

divide_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
divide_p64 p x y = mult_p64 p x (inverse_p64 p y);

minus_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
minus_p64 p x y = (if y <= x then x - y else x + p - y);

plus_p64 :: Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64 -> Uint64.Word64;
plus_p64 p x y = let {
                   z = x + y;
                 } in (if p <= z then z - p else z);

finite_field_ops64 :: Uint64.Word64 -> Arith_ops_record Uint64.Word64;
finite_field_ops64 p =
  Arith_Ops_Record (0 :: Uint64.Word64) (1 :: Uint64.Word64) (plus_p64 p)
    (mult_p64 p) (minus_p64 p) (uminus_p64 p) (divide_p64 p) (inverse_p64 p)
    (\ x y -> (if y == (0 :: Uint64.Word64) then x else (0 :: Uint64.Word64)))
    (\ x ->
      (if x == (0 :: Uint64.Word64) then (0 :: Uint64.Word64)
        else (1 :: Uint64.Word64)))
    (\ x -> x) uint64_of_int int_of_uint64
    (\ x -> (0 :: Uint64.Word64) <= x && x < p);

modulo_uint32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
modulo_uint32 x y = (if y == (0 :: Uint32.Word32) then x else Prelude.mod x y);

mult_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
mult_p32 p x y = modulo_uint32 (x * y) p;

power_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
power_p32 p x n =
  (if n == (0 :: Uint32.Word32) then (1 :: Uint32.Word32)
    else let {
           rec = power_p32 p (mult_p32 p x x)
                   (Data_Bits.shiftrBounded n (1 :: Integer));
         } in (if n Data_Bits..&. (1 :: Uint32.Word32) == (0 :: Uint32.Word32)
                then rec else mult_p32 p rec x));

inverse_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
inverse_p32 p x =
  (if x == (0 :: Uint32.Word32) then (0 :: Uint32.Word32)
    else power_p32 p x
           (p - (Prelude.fromInteger (2 :: Integer) :: Uint32.Word32)));

uminus_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
uminus_p32 p x =
  (if x == (0 :: Uint32.Word32) then (0 :: Uint32.Word32) else p - x);

divide_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
divide_p32 p x y = mult_p32 p x (inverse_p32 p y);

minus_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
minus_p32 p x y = (if y <= x then x - y else x + p - y);

plus_p32 :: Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32 -> Uint32.Word32;
plus_p32 p x y = let {
                   z = x + y;
                 } in (if p <= z then z - p else z);

finite_field_ops32 :: Uint32.Word32 -> Arith_ops_record Uint32.Word32;
finite_field_ops32 p =
  Arith_Ops_Record (0 :: Uint32.Word32) (1 :: Uint32.Word32) (plus_p32 p)
    (mult_p32 p) (minus_p32 p) (uminus_p32 p) (divide_p32 p) (inverse_p32 p)
    (\ x y -> (if y == (0 :: Uint32.Word32) then x else (0 :: Uint32.Word32)))
    (\ x ->
      (if x == (0 :: Uint32.Word32) then (0 :: Uint32.Word32)
        else (1 :: Uint32.Word32)))
    (\ x -> x) uint32_of_int int_of_uint32
    (\ x -> (0 :: Uint32.Word32) <= x && x < p);

to_int :: forall a. Arith_ops_record a -> a -> Int;
to_int (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x13;

to_int_poly_i :: forall a. Arith_ops_record a -> [a] -> Poly Int;
to_int_poly_i ops f = poly_of_list (map (to_int ops) f);

of_inta :: forall a. Arith_ops_record a -> Int -> a;
of_inta (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x12;

of_int_poly_i :: forall a. Arith_ops_record a -> Poly Int -> [a];
of_int_poly_i ops f = map (of_inta ops) (coeffs f);

unit_factora :: forall a. Arith_ops_record a -> a -> a;
unit_factora (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) =
  x11;

normalizeb :: forall a. Arith_ops_record a -> a -> a;
normalizeb (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) =
  x10;

moduloa :: forall a. Arith_ops_record a -> a -> a -> a;
moduloa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x9;

dividea :: forall a. Arith_ops_record a -> a -> a -> a;
dividea (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x7;

timesa :: forall a. Arith_ops_record a -> a -> a -> a;
timesa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x4;

minusa :: forall a. Arith_ops_record a -> a -> a -> a;
minusa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x5;

zeroa :: forall a. Arith_ops_record a -> a;
zeroa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x1;

onea :: forall a. Arith_ops_record a -> a;
onea (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x2;

euclid_ext_aux_i ::
  forall a.
    (Eq a) => Arith_ops_record a -> a -> a -> a -> a -> a -> a -> ((a, a), a);
euclid_ext_aux_i ops sa s ta t ra r =
  (if r == zeroa ops
    then let {
           c = dividea ops (onea ops) (unit_factora ops ra);
         } in ((timesa ops sa c, timesa ops ta c), normalizeb ops ra)
    else let {
           q = dividea ops ra r;
         } in euclid_ext_aux_i ops s (minusa ops sa (timesa ops q s)) t
                (minusa ops ta (timesa ops q t)) r (moduloa ops ra r));

uminusa :: forall a. Arith_ops_record a -> a -> a;
uminusa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x6;

lead_coeff_i :: forall a. Arith_ops_record a -> [a] -> a;
lead_coeff_i ops pp = (case pp of {
                        [] -> zeroa ops;
                        _ : _ -> last pp;
                      });

cCons_i :: forall a. (Eq a) => Arith_ops_record a -> a -> [a] -> [a];
cCons_i ops x xs = (if null xs && x == zeroa ops then [] else x : xs);

unit_factor_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a];
unit_factor_poly_i ops xs =
  cCons_i ops (unit_factora ops (lead_coeff_i ops xs)) [];

inversea :: forall a. Arith_ops_record a -> a -> a;
inversea (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x8;

smult_i :: forall a. (Eq a) => Arith_ops_record a -> a -> [a] -> [a];
smult_i ops a pp =
  (if a == zeroa ops then []
    else strip_while (\ aa -> zeroa ops == aa) (map (timesa ops a) pp));

normalize_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a];
normalize_poly_i ops xs =
  smult_i ops (inversea ops (unit_factora ops (lead_coeff_i ops xs))) xs;

minus_poly_rev_list_i :: forall a. Arith_ops_record a -> [a] -> [a] -> [a];
minus_poly_rev_list_i ops (x : xs) (y : ys) =
  minusa ops x y : minus_poly_rev_list_i ops xs ys;
minus_poly_rev_list_i ops xs [] = xs;
minus_poly_rev_list_i ops [] (y : ys) = [];

mod_poly_one_main_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> Nat -> [a];
mod_poly_one_main_i ops r d n =
  (if equal_nat n zero_nat then r
    else let {
           a = hd r;
           rr = tl (if a == zeroa ops then r
                     else minus_poly_rev_list_i ops r (map (timesa ops a) d));
         } in mod_poly_one_main_i ops rr d (minus_nat n one_nat));

poly_of_list_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a];
poly_of_list_i ops = strip_while (\ a -> zeroa ops == a);

mod_field_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
mod_field_poly_i ops cf cg =
  (if null cg then cf
    else let {
           ilc = inversea ops (last cg);
           ch = map (timesa ops ilc) cg;
           r = mod_poly_one_main_i ops (reverse cf) (reverse ch)
                 (minus_nat (plus_nat one_nat (size_list cf)) (size_list cg));
         } in poly_of_list_i ops (reverse r));

divmod_poly_one_main_i ::
  forall a.
    (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a] -> Nat -> ([a], [a]);
divmod_poly_one_main_i ops q r d n =
  (if equal_nat n zero_nat then (q, r)
    else let {
           a = hd r;
           qqq = cCons_i ops a q;
           rr = tl (if a == zeroa ops then r
                     else minus_poly_rev_list_i ops r (map (timesa ops a) d));
         } in divmod_poly_one_main_i ops qqq rr d (minus_nat n one_nat));

div_field_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
div_field_poly_i ops cf cg =
  (if null cg then []
    else let {
           ilc = inversea ops (last cg);
           ch = map (timesa ops ilc) cg;
           q = fst (divmod_poly_one_main_i ops [] (reverse cf) (reverse ch)
                     (minus_nat (plus_nat one_nat (size_list cf))
                       (size_list cg)));
         } in poly_of_list_i ops (map (timesa ops ilc) q));

coeffs_minus_i :: forall a. Arith_ops_record a -> [a] -> [a] -> [a];
coeffs_minus_i ops (x : xs) (y : ys) =
  minusa ops x y : coeffs_minus_i ops xs ys;
coeffs_minus_i ops xs [] = xs;
coeffs_minus_i ops [] (v : va) = map (uminusa ops) (v : va);

monom_mult_i :: forall a. Arith_ops_record a -> Nat -> [a] -> [a];
monom_mult_i ops n xs = (if null xs then xs else replicate n (zeroa ops) ++ xs);

minus_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
minus_poly_i ops (x : xs) (y : ys) =
  cCons_i ops (minusa ops x y) (minus_poly_i ops xs ys);
minus_poly_i ops xs [] = xs;
minus_poly_i ops [] (v : va) = map (uminusa ops) (v : va);

plusa :: forall a. Arith_ops_record a -> a -> a -> a;
plusa (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x3;

plus_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
plus_poly_i ops (x : xs) (y : ys) =
  cCons_i ops (plusa ops x y) (plus_poly_i ops xs ys);
plus_poly_i ops xs [] = xs;
plus_poly_i ops [] (v : va) = v : va;

karatsuba_main_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> Nat -> [a] -> Nat -> [a];
karatsuba_main_i ops f n g m =
  (if less_eq_nat n karatsuba_lower_bound || less_eq_nat m karatsuba_lower_bound
    then let {
           ff = poly_of_list_i ops f;
         } in foldr (\ a p ->
                      plus_poly_i ops (smult_i ops a ff)
                        (cCons_i ops (zeroa ops) p))
                g []
    else let {
           n2 = divide_nat n (nat_of_integer (2 :: Integer));
         } in (if less_nat n2 m
                then (case split_at n2 f of {
                       (f0, f1) ->
                         (case split_at n2 g of {
                           (g0, g1) ->
                             let {
                               p1 = karatsuba_main_i ops f1 (minus_nat n n2) g1
                                      (minus_nat m n2);
                               p2 = karatsuba_main_i ops
                                      (coeffs_minus_i ops f1 f0) n2
                                      (coeffs_minus_i ops g1 g0) n2;
                               p3 = karatsuba_main_i ops f0 n2 g0 n2;
                             } in plus_poly_i ops
                                    (monom_mult_i ops (plus_nat n2 n2) p1)
                                    (plus_poly_i ops
                                      (monom_mult_i ops n2
(plus_poly_i ops (minus_poly_i ops p1 p2) p3))
                                      p3);
                         });
                     })
                else (case split_at n2 f of {
                       (f0, f1) ->
                         let {
                           p1 = karatsuba_main_i ops f1 (minus_nat n n2) g m;
                           a = karatsuba_main_i ops f0 n2 g m;
                         } in plus_poly_i ops (monom_mult_i ops n2 p1) a;
                     })));

times_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
times_poly_i ops f g =
  let {
    n = size_list f;
    m = size_list g;
  } in (if less_eq_nat n karatsuba_lower_bound ||
             less_eq_nat m karatsuba_lower_bound
         then (if less_eq_nat n m
                then foldr (\ a p ->
                             plus_poly_i ops (smult_i ops a g)
                               (cCons_i ops (zeroa ops) p))
                       f []
                else foldr (\ a p ->
                             plus_poly_i ops (smult_i ops a f)
                               (cCons_i ops (zeroa ops) p))
                       g [])
         else (if less_eq_nat n m then karatsuba_main_i ops g m f n
                else karatsuba_main_i ops f n g m));

dp :: forall a. Arith_ops_record a -> a -> Bool;
dp (Arith_Ops_Record x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14) = x14;

is_poly :: forall a. (Eq a) => Arith_ops_record a -> [a] -> Bool;
is_poly ops xs =
  all (dp ops) xs && no_leading (\ a -> zeroa ops == a) (reverse xs);

poly_ops :: forall a. (Eq a) => Arith_ops_record a -> Arith_ops_record [a];
poly_ops ops =
  Arith_Ops_Record [] [onea ops] (plus_poly_i ops) (times_poly_i ops)
    (minus_poly_i ops) (map (uminusa ops)) (div_field_poly_i ops) (\ _ -> [])
    (mod_field_poly_i ops) (normalize_poly_i ops) (unit_factor_poly_i ops)
    (\ i -> (if equal_int i zero_int then [] else [of_inta ops i]))
    (\ _ -> zero_int) (is_poly ops);

euclid_ext_poly_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> (([a], [a]), [a]);
euclid_ext_poly_i ops =
  euclid_ext_aux_i (poly_ops ops) (onea (poly_ops ops)) (zeroa (poly_ops ops))
    (zeroa (poly_ops ops)) (onea (poly_ops ops));

bezout_coefficients_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> ([a], [a]);
bezout_coefficients_i ff_ops f g = fst (euclid_ext_poly_i ff_ops f g);

euclid_ext_poly_mod_main ::
  forall a.
    (Eq a) => Int ->
                Arith_ops_record a ->
                  Poly Int -> Poly Int -> (Poly Int, Poly Int);
euclid_ext_poly_mod_main p ff_ops f g =
  (case bezout_coefficients_i ff_ops (of_int_poly_i ff_ops f)
          (of_int_poly_i ff_ops g)
    of {
    (a, b) -> (to_int_poly_i ff_ops a, to_int_poly_i ff_ops b);
  });

euclid_ext_poly_dynamic :: Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
euclid_ext_poly_dynamic p =
  (if less_eq_int p (Int_of_integer (65535 :: Integer))
    then euclid_ext_poly_mod_main p (finite_field_ops32 (uint32_of_int p))
    else (if less_eq_int p (Int_of_integer (4294967295 :: Integer))
           then euclid_ext_poly_mod_main p
                  (finite_field_ops64 (uint64_of_int p))
           else euclid_ext_poly_mod_main p
                  (finite_field_ops_integer (integer_of_int p))));

pdivmod_monic_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> ([a], [a]);
pdivmod_monic_i ops cf cg =
  (case divmod_poly_one_main_i ops [] (reverse cf) (reverse cg)
          (minus_nat (plus_nat one_nat (size_list cf)) (size_list cg))
    of {
    (q, r) -> (poly_of_list_i ops q, poly_of_list_i ops (reverse r));
  });

dupe_monic_i ::
  forall a.
    (Eq a) => Arith_ops_record a ->
                [a] -> [a] -> [a] -> [a] -> [a] -> ([a], [a]);
dupe_monic_i ops d h s t u =
  (case pdivmod_monic_i ops (times_poly_i ops t u) d of {
    (q, a) ->
      (plus_poly_i ops (times_poly_i ops s u) (times_poly_i ops h q), a);
  });

dupe_monic_i_int ::
  forall a.
    (Eq a) => Arith_ops_record a ->
                Poly Int ->
                  Poly Int ->
                    Poly Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
dupe_monic_i_int ops d h s t =
  let {
    da = of_int_poly_i ops d;
    ha = of_int_poly_i ops h;
    sa = of_int_poly_i ops s;
    ta = of_int_poly_i ops t;
  } in (\ u -> (case dupe_monic_i ops da ha sa ta (of_int_poly_i ops u) of {
                 (db, hb) -> (to_int_poly_i ops db, to_int_poly_i ops hb);
               }));

dupe_monic_dynamic ::
  Int ->
    Poly Int ->
      Poly Int -> Poly Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
dupe_monic_dynamic p =
  (if less_eq_int p (Int_of_integer (65535 :: Integer))
    then dupe_monic_i_int (finite_field_ops32 (uint32_of_int p))
    else (if less_eq_int p (Int_of_integer (4294967295 :: Integer))
           then dupe_monic_i_int (finite_field_ops64 (uint64_of_int p))
           else dupe_monic_i_int
                  (finite_field_ops_integer (integer_of_int p))));

simple_quadratic_hensel_step ::
  Poly Int ->
    Int -> Poly Int -> Poly Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
simple_quadratic_hensel_step c q s t d h =
  let {
    u = mp q (sdiv_poly (minus_poly c (karatsuba_mult_poly d h)) q);
    a = dupe_monic_dynamic q d h s t u;
  } in (case a of {
         (aa, b) -> let {
                      da = plus_poly d (smult q b);
                      ab = plus_poly h (smult q aa);
                    } in (da, ab);
       });

one_poly :: forall a. (Comm_semiring_1 a) => Poly a;
one_poly = Poly [one];

quadratic_hensel_step ::
  Poly Int ->
    Int ->
      Poly Int ->
        Poly Int ->
          Poly Int -> Poly Int -> (Poly Int, (Poly Int, (Poly Int, Poly Int)));
quadratic_hensel_step c q s t d h =
  let {
    dupe = dupe_monic_dynamic q d h s t;
    u = mp q (sdiv_poly (minus_poly c (karatsuba_mult_poly d h)) q);
    a = dupe u;
  } in (case a of {
         (aa, b) ->
           let {
             da = plus_poly d (smult q b);
             ha = plus_poly h (smult q aa);
             ua = mp q (sdiv_poly
                         (minus_poly
                           (plus_poly (karatsuba_mult_poly s da)
                             (karatsuba_mult_poly t ha))
                           one_poly)
                         q);
             ab = dupe ua;
           } in (case ab of {
                  (ac, ba) -> let {
                                qa = times_int q q;
                                sa = mp qa (minus_poly s (smult q ac));
                                ta = mp qa (minus_poly t (smult q ba));
                              } in (sa, (ta, (da, ha)));
                });
       });

quadratic_hensel_loop ::
  Poly Int ->
    Int ->
      Poly Int ->
        Poly Int ->
          Poly Int ->
            Poly Int ->
              Nat -> (Int, (Poly Int, (Poly Int, (Poly Int, Poly Int))));
quadratic_hensel_loop c p s1 t1 d1 h1 j =
  (if less_eq_nat j one_nat then (p, (s1, (t1, (d1, h1))))
    else (if dvd (nat_of_integer (2 :: Integer)) j
           then (case quadratic_hensel_loop c p s1 t1 d1 h1
                        (divide_nat j (nat_of_integer (2 :: Integer)))
                  of {
                  (q, (s, (t, (d, h)))) ->
                    let {
                      qq = times_int q q;
                    } in (case quadratic_hensel_step c q s t d h of {
                           (sa, (ta, (da, ha))) -> (qq, (sa, (ta, (da, ha))));
                         });
                })
           else (case quadratic_hensel_loop c p s1 t1 d1 h1
                        (plus_nat (divide_nat j (nat_of_integer (2 :: Integer)))
                          one_nat)
                  of {
                  (q, (s, (t, (d, h)))) ->
                    (case quadratic_hensel_step c q s t d h of {
                      (sa, (ta, (da, ha))) ->
                        let {
                          qq = times_int q q;
                          pj = divide_int qq p;
                          down = mp pj;
                        } in (pj, (down sa, (down ta, (down da, down ha))));
                    });
                })));

quadratic_hensel_main ::
  Poly Int ->
    Int ->
      Poly Int ->
        Poly Int -> Poly Int -> Poly Int -> Nat -> (Poly Int, Poly Int);
quadratic_hensel_main c p s1 t1 d1 h1 j =
  (if less_eq_nat j one_nat then (d1, h1)
    else (if dvd (nat_of_integer (2 :: Integer)) j
           then (case quadratic_hensel_loop c p s1 t1 d1 h1
                        (divide_nat j (nat_of_integer (2 :: Integer)))
                  of {
                  (q, a) ->
                    (case a of {
                      (s, aa) ->
                        (case aa of {
                          (t, ab) ->
                            (case ab of {
                              (ac, b) ->
                                simple_quadratic_hensel_step c q s t ac b;
                            });
                        });
                    });
                })
           else (case quadratic_hensel_loop c p s1 t1 d1 h1
                        (plus_nat (divide_nat j (nat_of_integer (2 :: Integer)))
                          one_nat)
                  of {
                  (q, (s, (t, (d, h)))) ->
                    (case simple_quadratic_hensel_step c q s t d h of {
                      (da, ha) -> let {
                                    down = mp (divide_int (times_int q q) p);
                                  } in (down da, down ha);
                    });
                })));

quadratic_hensel_binary ::
  Int -> Nat -> Poly Int -> Poly Int -> Poly Int -> (Poly Int, Poly Int);
quadratic_hensel_binary p n c d h =
  (case euclid_ext_poly_dynamic p d h of {
    (s, t) -> quadratic_hensel_main c p s t d h n;
  });

hensel_lifting_main ::
  Int -> Nat -> Poly Int -> Factor_tree (Poly Int) -> [Poly Int];
hensel_lifting_main p n u (Factor_Leaf uu uv) = [u];
hensel_lifting_main p n u (Factor_Node uw l r) =
  let {
    v = factor_node_info l;
    w = factor_node_info r;
  } in (case quadratic_hensel_binary p n u v w of {
         (va, wa) ->
           hensel_lifting_main p n va l ++ hensel_lifting_main p n wa r;
       });

partition_factors_main ::
  forall a. Nat -> [(a, Nat)] -> ([(a, Nat)], [(a, Nat)]);
partition_factors_main s [] = ([], []);
partition_factors_main s ((f, d) : xs) =
  (if less_eq_nat d s then (case partition_factors_main (minus_nat s d) xs of {
                             (l, a) -> ((f, d) : l, a);
                           })
    else (case partition_factors_main d xs of {
           (l, r) -> (l, (f, d) : r);
         }));

partition_factors :: forall a. [(a, Nat)] -> ([(a, Nat)], [(a, Nat)]);
partition_factors xs =
  let {
    n = divide_nat (sum_list (map snd xs)) (nat_of_integer (2 :: Integer));
  } in (case partition_factors_main n xs of {
         ([], []) -> ([], []);
         ([], [x]) -> ([], [x]);
         ([], x : y : ys) -> ([x], y : ys);
         ([x], b) -> ([x], b);
         (x : y : ys, []) -> ([x], y : ys);
         (x : y : ys, ad : listb) -> (x : y : ys, ad : listb);
       });

create_factor_tree_balanced :: [(Poly Int, Nat)] -> Factor_tree ();
create_factor_tree_balanced xs =
  (if less_eq_nat (size_list xs) one_nat then Factor_Leaf () (fst (hd xs))
    else (case partition_factors xs of {
           (l, r) ->
             Factor_Node () (create_factor_tree_balanced l)
               (create_factor_tree_balanced r);
         }));

create_factor_tree :: [Poly Int] -> Factor_tree ();
create_factor_tree xs = let {
                          ys = map (\ f -> (f, degree f)) xs;
                          a = reverse (sort_key snd ys);
                        } in create_factor_tree_balanced a;

hensel_lifting_monic :: Int -> Nat -> Poly Int -> [Poly Int] -> [Poly Int];
hensel_lifting_monic p n u vs =
  (if null vs then []
    else let {
           pn = binary_power p n;
           c = mp pn u;
           a = product_factor_tree p (create_factor_tree vs);
         } in hensel_lifting_main p n c a);

hensel_lifting :: Int -> Nat -> Poly Int -> [Poly Int] -> [Poly Int];
hensel_lifting p n f gs = let {
                            lc = coeff f (degree f);
                            ilc = inverse_mod lc (binary_power p n);
                            g = smult ilc f;
                          } in hensel_lifting_monic p n g gs;

mat_multrow_gen_impl ::
  forall a. (a -> a -> a) -> Nat -> a -> Mat_impl a -> Mat_impl a;
mat_multrow_gen_impl xc xd xe xf =
  Abs_mat_impl
    (case rep_mat_impl xf of {
      (nr, a) ->
        (case a of {
          (nc, aa) -> let {
                        ak = sub aa xd;
                        arows = list_of aa;
                        aka = IArray.listIArray (map (xc xe) (list_of ak));
                        ab = IArray.listIArray (list_update arows xd aka);
                      } in (nr, (nc, ab));
        });
    });

mat_multrow_gen :: forall a. (a -> a -> a) -> Nat -> a -> Mat a -> Mat a;
mat_multrow_gen mul k aa (Mat_impl a) =
  Mat_impl (mat_multrow_gen_impl mul k aa a);

multrow_i :: forall a. Arith_ops_record a -> Nat -> a -> Mat a -> Mat a;
multrow_i ops = mat_multrow_gen (timesa ops);

sqrt_int_maina :: Int -> Int -> (Int, Bool);
sqrt_int_maina x n =
  let {
    x2 = times_int x x;
  } in (if less_eq_int x2 n then (x, equal_int x2 n)
         else sqrt_int_maina
                (divide_int (plus_int (divide_int n x) x)
                  (Int_of_integer (2 :: Integer)))
                n);

sqrt_int_main :: Int -> (Int, Bool);
sqrt_int_main x =
  sqrt_int_maina (start_value x (nat_of_integer (2 :: Integer))) x;

strict_test :: [[Integer]] -> [[Integer]];
strict_test xs =
  ((basis_to_list .
     strictly_reduce_basis (size_list xs)
       (of_int (Int_of_integer (2 :: Integer)))) .
    list_to_basis)
    xs;

list_to_poly :: [Integer] -> Poly Int;
list_to_poly = poly_of_list . map Int_of_integer;

poly_to_list :: Poly Int -> [Integer];
poly_to_list = map integer_of_int . coeffs;

max_degree_poly :: Poly Int -> Poly Int -> Poly Int;
max_degree_poly a b = (if less_eq_nat (degree b) (degree a) then a else b);

choose_u :: [Poly Int] -> Poly Int;
choose_u [] = error "undefined";
choose_u [gi] = gi;
choose_u (gi : gj : gs) = max_degree_poly gi (choose_u (gj : gs));

gcd_eucl_i :: forall a. (Eq a) => Arith_ops_record a -> a -> a -> a;
gcd_eucl_i ops a b =
  (if b == zeroa ops then normalizeb ops a
    else gcd_eucl_i ops b (moduloa ops a b));

gcd_poly_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a];
gcd_poly_i ops = gcd_eucl_i (poly_ops ops);

pderiv_main_i :: forall a. (Eq a) => Arith_ops_record a -> a -> [a] -> [a];
pderiv_main_i ops f (x : xs) =
  cCons_i ops (timesa ops f x) (pderiv_main_i ops (plusa ops f (onea ops)) xs);
pderiv_main_i ops f [] = [];

pderiv_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> [a];
pderiv_i ops xs = pderiv_main_i ops (onea ops) (tl xs);

square_free_i :: forall a. (Eq a) => Arith_ops_record a -> [a] -> Bool;
square_free_i ops xs = gcd_poly_i ops xs (pderiv_i ops xs) == [onea ops];

square_free_impl_main ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> Poly Int -> Bool;
square_free_impl_main p ff_ops f =
  square_free_i ff_ops (of_int_poly_i ff_ops (mp p f));

square_free_impl :: Int -> Poly Int -> Bool;
square_free_impl p =
  (if less_eq_int p (Int_of_integer (65535 :: Integer))
    then square_free_impl_main p (finite_field_ops32 (uint32_of_int p))
    else (if less_eq_int p (Int_of_integer (4294967295 :: Integer))
           then square_free_impl_main p (finite_field_ops64 (uint64_of_int p))
           else square_free_impl_main p
                  (finite_field_ops_integer (integer_of_int p))));

degree_i :: forall a. [a] -> Nat;
degree_i pp = minus_nat (size_list pp) one_nat;

sqrt_int_ceiling_pos :: Int -> Int;
sqrt_int_ceiling_pos x = (case sqrt_int_main x of {
                           (y, True) -> y;
                           (y, False) -> plus_int y one_int;
                         });

sqrt_int_floor_pos :: Int -> Int;
sqrt_int_floor_pos x = fst (sqrt_int_main x);

sqrt_int_ceiling :: Int -> Int;
sqrt_int_ceiling x =
  (if less_eq_int zero_int x then sqrt_int_ceiling_pos x
    else uminus_int (sqrt_int_floor_pos (uminus_int x)));

coprime :: forall a. (Semiring_gcd a, Eq a) => a -> a -> Bool;
coprime = (\ x y -> gcda x y == one);

suitable_prime_bz :: Poly Int -> Int;
suitable_prime_bz f =
  let {
    lc = coeff f (degree f);
  } in int_of_nat
         (find_prime (\ n -> let {
                               p = int_of_nat n;
                             } in coprime lc p && square_free_impl p f));

find_exponent_main :: Int -> Int -> Nat -> Int -> Nat;
find_exponent_main p pm m bnd =
  (if less_int bnd pm then m
    else find_exponent_main p (times_int pm p) (suc m) bnd);

find_exponent :: Int -> Int -> Nat;
find_exponent p bnd = find_exponent_main p p one_nat bnd;

short_norm_test :: [[Integer]] -> Integer;
short_norm_test =
  ((integer_of_int . sq_norm_vec) .
    short_vector (of_int (Int_of_integer (2 :: Integer)))) .
    list_to_basis;

divide_poly :: forall a. (Eq a, Idom_divide a) => Poly a -> Poly a -> Poly a;
divide_poly f g = divide_poly_list f g;

normalize_poly ::
  forall a.
    (Eq a, Idom_divide a, Semidom_divide_unit_factor a) => Poly a -> Poly a;
normalize_poly p =
  divide_poly p (pCons (unit_factor (coeff p (degree p))) zero_poly);

gcd_poly_code_aux ::
  forall a. (Factorial_ring_gcd a, Eq a) => Poly a -> Poly a -> Poly a;
gcd_poly_code_aux p q =
  (if (case coeffs q of {
        [] -> True;
        _ : _ -> False;
      })
    then normalize_poly p
    else gcd_poly_code_aux q (primitive_part (pseudo_mod p q)));

gcd_poly_code ::
  forall a. (Factorial_ring_gcd a, Eq a) => Poly a -> Poly a -> Poly a;
gcd_poly_code p q =
  (if (case coeffs p of {
        [] -> True;
        _ : _ -> False;
      })
    then normalize_poly q
    else (if (case coeffs q of {
               [] -> True;
               _ : _ -> False;
             })
           then normalize_poly p
           else let {
                  c1 = content p;
                  c2 = content q;
                  pa = map_poly (\ x -> divide x c1) p;
                  qa = map_poly (\ x -> divide x c2) q;
                } in smult (gcda c1 c2) (gcd_poly_code_aux pa qa)));

mat_swaprows_impl :: forall a. Nat -> Nat -> Mat_impl a -> Mat_impl a;
mat_swaprows_impl xc xd xe =
  Abs_mat_impl
    (case rep_mat_impl xe of {
      (nr, a) ->
        (case a of {
          (nc, aa) ->
            (if less_nat xc nr && less_nat xd nr
              then let {
                     ai = sub aa xc;
                     aj = sub aa xd;
                     arows = list_of aa;
                     ab = IArray.listIArray
                            (list_update (list_update arows xc aj) xd ai);
                   } in (nr, (nc, ab))
              else (nr, (nc, aa)));
        });
    });

mat_swaprows :: forall a. Nat -> Nat -> Mat a -> Mat a;
mat_swaprows k l (Mat_impl a) =
  let {
    nr = dim_row_impl a;
  } in (if less_nat l nr && less_nat k nr
         then Mat_impl (mat_swaprows_impl k l a)
         else (error :: forall a. String -> (() -> a) -> a)
                "index out of bounds in mat_swaprows"
                (\ _ -> mat_swaprows k l (Mat_impl a)));

eliminate_entries_i2 ::
  forall a.
    (Eq a) => a -> (a -> a -> a) ->
                     (a -> a -> a) ->
                       (Integer -> a) -> Mat_impl a -> Integer -> Mat_impl a;
eliminate_entries_i2 xc xe xg xh xi xj =
  Abs_mat_impl
    ((case rep_mat_impl xi of {
       (nr, a) ->
         (case a of {
           (nc, aa) ->
             (\ i ->
               (nr, (nc, let {
                           ai = (IArray.!) aa i;
                         } in IArray.array
                                (\ ia ->
                                  let {
                                    aia = (IArray.!) aa ia;
                                  } in (if ia == i then aia
 else let {
        vi_j = xh ia;
      } in (if vi_j == xc then aia
             else IArray.array
                    (\ j -> xe ((IArray.!) aia j) (xg vi_j ((IArray.!) ai j)))
                    (integer_of_nat nc))))
                                (integer_of_nat nr))));
         });
     })
      xj);

eliminate_entries_gen_zero ::
  forall a.
    (Eq a) => (a -> a -> a) ->
                (a -> a -> a) ->
                  a -> (Integer -> a) -> Mat a -> Nat -> Nat -> Mat a;
eliminate_entries_gen_zero mm tt z v (Mat_impl m) i j =
  (if less_nat i (dim_row_impl m)
    then Mat_impl (eliminate_entries_i2 z mm tt v m (integer_of_nat i))
    else (error :: forall a. String -> (() -> a) -> a)
           "index out of range in eliminate_entries"
           (\ _ -> eliminate_entries_gen_zero mm tt z v (Mat_impl m) i j));

eliminate_entries_i ::
  forall a.
    (Eq a) => Arith_ops_record a ->
                (Integer -> a) -> Mat a -> Nat -> Nat -> Mat a;
eliminate_entries_i ops =
  eliminate_entries_gen_zero (minusa ops) (timesa ops) (zeroa ops);

pivot_positions_main_gen ::
  forall a. (Eq a) => a -> Mat a -> Nat -> Nat -> Nat -> Nat -> [(Nat, Nat)];
pivot_positions_main_gen zero a nr nc i j =
  (if less_nat i nr
    then (if less_nat j nc
           then (if index_mat a (i, j) == zero
                  then pivot_positions_main_gen zero a nr nc i (suc j)
                  else (i, j) :
                         pivot_positions_main_gen zero a nr nc (suc i) (suc j))
           else [])
    else []);

pivot_positions_gen :: forall a. (Eq a) => a -> Mat a -> [(Nat, Nat)];
pivot_positions_gen zer a =
  pivot_positions_main_gen zer a (dim_row a) (dim_col a) zero_nat zero_nat;

non_pivot_base_gen ::
  forall a. (a -> a) -> a -> a -> Mat a -> [(Nat, Nat)] -> Nat -> Vec a;
non_pivot_base_gen uminus zero one a pivots =
  let {
    _ = dim_row a;
    nc = dim_col a;
    invers = map_of (map swap pivots);
  } in (\ qj ->
         vec nc
           (\ i ->
             (if equal_nat i qj then one
               else (case invers i of {
                      Nothing -> zero;
                      Just j -> uminus (index_mat a (j, qj));
                    }))));

find_base_vectors_gen ::
  forall a. (Eq a) => (a -> a) -> a -> a -> Mat a -> [Vec a];
find_base_vectors_gen uminus zero one a =
  let {
    pp = pivot_positions_gen zero a;
    b = filter (\ j -> not (member (map snd pp) j)) (upt zero_nat (dim_col a));
  } in map (non_pivot_base_gen uminus zero one a pp) b;

find_base_vectors_i ::
  forall a. (Eq a) => Arith_ops_record a -> Mat a -> [Vec a];
find_base_vectors_i ops a =
  find_base_vectors_gen (uminusa ops) (zeroa ops) (onea ops) a;

gauss_jordan_main_i ::
  forall a.
    (Eq a) => Arith_ops_record a -> Nat -> Nat -> Mat a -> Nat -> Nat -> Mat a;
gauss_jordan_main_i ops nr nc a i j =
  (if less_nat i nr && less_nat j nc
    then let {
           aij = index_mat a (i, j);
         } in (if aij == zeroa ops
                then (case concatMap
                             (\ ia ->
                               (if not (index_mat a (ia, j) == zeroa ops)
                                 then [ia] else []))
                             (upt (suc i) nr)
                       of {
                       [] -> gauss_jordan_main_i ops nr nc a i (suc j);
                       ia : _ ->
                         gauss_jordan_main_i ops nr nc (mat_swaprows i ia a) i
                           j;
                     })
                else (if aij == onea ops
                       then let {
                              v = (\ ia -> index_mat a (nat_of_integer ia, j));
                            } in gauss_jordan_main_i ops nr nc
                                   (eliminate_entries_i ops v a i j) (suc i)
                                   (suc j)
                       else let {
                              iaij = inversea ops aij;
                              aa = multrow_i ops i iaij a;
                              v = (\ ia -> index_mat aa (nat_of_integer ia, j));
                            } in gauss_jordan_main_i ops nr nc
                                   (eliminate_entries_i ops v aa i j) (suc i)
                                   (suc j)))
    else a);

power_poly_f_mod_i ::
  forall a. (Eq a) => Arith_ops_record a -> ([a] -> [a]) -> [a] -> Nat -> [a];
power_poly_f_mod_i ff_ops modulus a n =
  (if equal_nat n zero_nat then modulus [onea ff_ops]
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (d, r) ->
             let {
               rec = power_poly_f_mod_i ff_ops modulus
                       (modulus (times_poly_i ff_ops a a)) d;
             } in (if equal_nat r zero_nat then rec
                    else modulus (times_poly_i ff_ops rec a));
         }));

dist_degree_factorize_main_i ::
  forall a.
    (Eq a) => Int ->
                Arith_ops_record a ->
                  a -> a -> Nat ->
                              [a] -> [a] -> Nat -> [(Nat, [a])] -> [(Nat, [a])];
dist_degree_factorize_main_i p ff_ops ze on dv v w d res =
  (if v == [on] then res
    else (if less_nat dv (plus_nat d d) then (dv, v) : res
           else let {
                  wa = power_poly_f_mod_i ff_ops
                         (\ f -> mod_field_poly_i ff_ops f v) w (nat p);
                  da = suc d;
                  gd = gcd_poly_i ff_ops (minus_poly_i ff_ops wa [ze, on]) v;
                } in (if gd == [on]
                       then dist_degree_factorize_main_i p ff_ops ze on dv v wa
                              da res
                       else let {
                              va = div_field_poly_i ff_ops v gd;
                            } in dist_degree_factorize_main_i p ff_ops ze on
                                   (degree_i va) va
                                   (mod_field_poly_i ff_ops wa va) da
                                   ((da, gd) : res))));

distinct_degree_factorization_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> [a] -> [(Nat, [a])];
distinct_degree_factorization_i p ff_ops f =
  let {
    ze = zeroa ff_ops;
    on = onea ff_ops;
  } in (if equal_nat (degree_i f) one_nat then [(one_nat, f)]
         else dist_degree_factorize_main_i p ff_ops ze on (degree_i f) f
                [ze, on] zero_nat []);

berlekamp_factorization_main_i ::
  forall a.
    (Eq a) => Int ->
                Arith_ops_record a ->
                  a -> a -> Nat -> [[a]] -> [[a]] -> Nat -> [[a]];
berlekamp_factorization_main_i p ff_ops ze on d divs (v : vs) n =
  (if v == [on] then berlekamp_factorization_main_i p ff_ops ze on d divs vs n
    else (if equal_nat (size_list divs) n then divs
           else let {
                  of_int = of_inta ff_ops;
                  facts =
                    filter (\ w -> not (w == [on]))
                      (concatMap
                        (\ u ->
                          map (\ s ->
                                gcd_poly_i ff_ops u
                                  (minus_poly_i ff_ops v
                                    (if equal_nat s zero_nat then []
                                      else [of_int (int_of_nat s)])))
                            (upt zero_nat (nat p)))
                        divs);
                } in (case partition (\ q -> equal_nat (degree_i q) d) facts of
                       {
                       (lin, nonlin) ->
                         lin ++
                           berlekamp_factorization_main_i p ff_ops ze on d
                             nonlin vs (minus_nat n (size_list lin));
                     })));
berlekamp_factorization_main_i p ff_ops ze on d divs [] n = divs;

power_polys_i ::
  forall a. (Eq a) => Arith_ops_record a -> [a] -> [a] -> [a] -> Nat -> [[a]];
power_polys_i ff_ops mul_p u curr_p i =
  (if equal_nat i zero_nat then []
    else curr_p :
           power_polys_i ff_ops mul_p u
             (mod_field_poly_i ff_ops (times_poly_i ff_ops curr_p mul_p) u)
             (minus_nat i one_nat));

berlekamp_mat_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> [a] -> Mat a;
berlekamp_mat_i p ff_ops u =
  let {
    n = degree_i u;
    ze = zeroa ff_ops;
    on = onea ff_ops;
    mul_p =
      power_poly_f_mod_i ff_ops (\ v -> mod_field_poly_i ff_ops v u) [ze, on]
        (nat p);
    xks = power_polys_i ff_ops mul_p u [on] n;
  } in mat_of_rows_list n
         (map (\ cs -> cs ++ replicate (minus_nat n (size_list cs)) ze) xks);

gauss_jordan_single_i ::
  forall a. (Eq a) => Arith_ops_record a -> Mat a -> Mat a;
gauss_jordan_single_i ops a =
  gauss_jordan_main_i ops (dim_row a) (dim_col a) a zero_nat zero_nat;

berlekamp_resulting_mat_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> [a] -> Mat a;
berlekamp_resulting_mat_i p ff_ops u =
  let {
    q = berlekamp_mat_i p ff_ops u;
    n = dim_row q;
    qi = mat n n
           (\ (i, j) ->
             (if equal_nat i j
               then minusa ff_ops (index_mat q (i, j)) (onea ff_ops)
               else index_mat q (i, j)));
  } in gauss_jordan_single_i ff_ops (transpose_mat qi);

berlekamp_basis_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> [a] -> [[a]];
berlekamp_basis_i p ff_ops u =
  map (poly_of_list_i ff_ops . list_of_vec)
    (find_base_vectors_i ff_ops (berlekamp_resulting_mat_i p ff_ops u));

berlekamp_monic_factorization_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> Nat -> [a] -> [[a]];
berlekamp_monic_factorization_i p ff_ops d f =
  let {
    vs = berlekamp_basis_i p ff_ops f;
  } in berlekamp_factorization_main_i p ff_ops (zeroa ff_ops) (onea ff_ops) d
         [f] vs (size_list vs);

finite_field_factorization_i ::
  forall a. (Eq a) => Int -> Arith_ops_record a -> [a] -> (a, [[a]]);
finite_field_factorization_i p ff_ops f =
  (if equal_nat (degree_i f) zero_nat then (lead_coeff_i ff_ops f, [])
    else let {
           a = lead_coeff_i ff_ops f;
           u = smult_i ff_ops (inversea ff_ops a) f;
           gs = (if False then distinct_degree_factorization_i p ff_ops u
                  else [(one_nat, u)]);
         } in (case partition (\ (i, fa) -> equal_nat (degree_i fa) i) gs of {
                (irr, hs) ->
                  (a, map snd irr ++
                        concatMap
                          (\ (aa, b) ->
                            berlekamp_monic_factorization_i p ff_ops aa b)
                          hs);
              }));

finite_field_factorization_main ::
  forall a.
    (Eq a) => Int -> Arith_ops_record a -> Poly Int -> (Int, [Poly Int]);
finite_field_factorization_main p f_ops f =
  (case finite_field_factorization_i p f_ops (of_int_poly_i f_ops (mp p f)) of {
    (c, fs) -> (to_int f_ops c, map (to_int_poly_i f_ops) fs);
  });

finite_field_factorization_int :: Int -> Poly Int -> (Int, [Poly Int]);
finite_field_factorization_int p =
  (if less_eq_int p (Int_of_integer (65535 :: Integer))
    then finite_field_factorization_main p
           (finite_field_ops32 (uint32_of_int p))
    else (if less_eq_int p (Int_of_integer (4294967295 :: Integer))
           then finite_field_factorization_main p
                  (finite_field_ops64 (uint64_of_int p))
           else finite_field_factorization_main p
                  (finite_field_ops_integer (integer_of_int p))));

factorization_lattice ::
  forall a. (Eq a, Comm_semiring_1 a) => Poly a -> Nat -> a -> [Vec a];
factorization_lattice u k m =
  let {
    n = degree u;
  } in map (\ i -> vec_of_poly_n (monom_mult i u) (plus_nat n k))
         (rev_upt k zero_nat) ++
         map (\ i -> vec_of_poly_n (monom m i) (plus_nat n k))
           (rev_upt n zero_nat);

lLL_short_polynomial :: Int -> Nat -> Poly Int -> Poly Int;
lLL_short_polynomial pl n u =
  poly_of_vec
    (short_vector (of_int (Int_of_integer (2 :: Integer)))
      (factorization_lattice u (minus_nat n (degree u)) pl));

gcd_poly ::
  forall a. (Factorial_ring_gcd a, Eq a) => Poly a -> Poly a -> Poly a;
gcd_poly p q = gcd_poly_code p q;

lLL_reconstructiona :: Int -> Int -> Poly Int -> [Poly Int] -> [Poly Int];
lLL_reconstructiona p pl f us =
  let {
    u = choose_u us;
  } in (if not (less_eq_nat (degree u) (degree f) &&
                 not (equal_nat (degree u) zero_nat) &&
                   not (equal_int pl zero_int))
         then (error :: forall a. String -> (() -> a) -> a)
                "LLL_reconstruction is invoked with non-suitable arguments"
                (\ _ -> [])
         else let {
                g = lLL_short_polynomial pl (degree f) u;
                f2 = gcd_poly f g;
              } in (if equal_nat (degree f2) zero_nat then [f]
                     else let {
                            f1 = divide_poly f f2;
                          } in (case partition (\ gi -> dvdm p gi f1) us of {
                                 (us1, us2) ->
                                   lLL_reconstructiona p pl f1 us1 ++
                                     lLL_reconstructiona p pl f2 us2;
                               })));

lLL_factorization :: Poly Int -> [Poly Int];
lLL_factorization f =
  let {
    p = suitable_prime_bz f;
  } in (case finite_field_factorization_int p f of {
         (_, fs) ->
           let {
             n = degree f;
             no = sq_norm_poly f;
             b = sqrt_int_ceiling
                   (times_int
                     (binary_power (Int_of_integer (2 :: Integer))
                       (times_nat (times_nat (nat_of_integer (5 :: Integer)) n)
                         (minus_nat n one_nat)))
                     (binary_power no
                       (minus_nat (times_nat (nat_of_integer (2 :: Integer)) n)
                         one_nat)));
             l = find_exponent p b;
             us = hensel_lifting p l f fs;
             pl = binary_power p l;
           } in lLL_reconstructiona p pl f us;
       });

lLL_factorization_test :: [Integer] -> [[Integer]];
lLL_factorization_test xs =
  ((map poly_to_list . lLL_factorization) . list_to_poly) xs;

lLL_reconstruction_inner ::
  Int ->
    Int ->
      [Poly Int] ->
        Poly Int ->
          Poly Int -> Nat -> Maybe ([Poly Int], (Int, (Poly Int, Poly Int)));
lLL_reconstruction_inner p pl gs f u j =
  let {
    g = lLL_short_polynomial pl j u;
  } in (if less_eq_int pl (abs_int (coeff g (degree g))) then Nothing
         else let {
                ppg = primitive_part g;
              } in (case div_int_poly f ppg of {
                     Nothing -> Nothing;
                     Just fa ->
                       Just (filter (\ gi -> not (dvdm p gi ppg)) gs,
                              (coeff fa (degree fa), (fa, ppg)));
                   }));

lLL_reconstruction_inner_loop ::
  Int ->
    Int ->
      [Poly Int] ->
        Poly Int ->
          Poly Int -> Nat -> ([Poly Int], (Int, (Poly Int, Poly Int)));
lLL_reconstruction_inner_loop p pl gs f u j =
  (if less_nat (degree f) j then ([], (one_int, (one_poly, f)))
    else (case lLL_reconstruction_inner p pl gs f u j of {
           Nothing ->
             lLL_reconstruction_inner_loop p pl gs f u (plus_nat j one_nat);
           Just tuple -> tuple;
         }));

lLL_reconstruction ::
  Int -> Int -> [Poly Int] -> Int -> Poly Int -> [Poly Int] -> [Poly Int];
lLL_reconstruction p pl gs b f factors =
  (if null gs then factors
    else let {
           u = choose_u gs;
           d = degree u;
         } in (case lLL_reconstruction_inner_loop p pl gs f u
                      (plus_nat d one_nat)
                of {
                (gsa, (ba, (fa, factor))) ->
                  lLL_reconstruction p pl gsa ba fa (factor : factors);
              }));

reconstruction_of_algorithm_16_22 ::
  Int -> Int -> [Poly Int] -> Poly Int -> [Poly Int];
reconstruction_of_algorithm_16_22 p pl gs f =
  let {
    g = [];
    b = coeff f (degree f);
  } in lLL_reconstruction p pl gs b f g;

factorization_algorithm_16_22 :: Poly Int -> [Poly Int];
factorization_algorithm_16_22 f =
  let {
    p = suitable_prime_bz f;
  } in (case finite_field_factorization_int p f of {
         (_, fs) ->
           let {
             n = degree f;
             no = times_int (int_of_nat (plus_nat n one_nat))
                    (binary_power (linf_norm_poly f)
                      (nat_of_integer (2 :: Integer)));
             b = sqrt_int_ceiling
                   (times_int
                     (binary_power (Int_of_integer (2 :: Integer))
                       (times_nat (times_nat (nat_of_integer (5 :: Integer)) n)
                         n))
                     (binary_power no
                       (times_nat (nat_of_integer (2 :: Integer)) n)));
             l = find_exponent p b;
             vs = hensel_lifting p l f fs;
           } in reconstruction_of_algorithm_16_22 p (binary_power p l) vs f;
       });

factorization_algorithm_16_22_test :: [Integer] -> [[Integer]];
factorization_algorithm_16_22_test xs =
  ((map poly_to_list . factorization_algorithm_16_22) . list_to_poly) xs;

}
